From 2e30f592f77f99d252b05e008957e324a8299d60 Mon Sep 17 00:00:00 2001
From: Baochen Qiang <bqiang@codeaurora.org>
Date: Mon, 11 Jan 2021 11:07:21 +0800
Subject: [PATCH 69/76] ath11k: add dp support for WCN6850

hal rx descriptor is different for WCN6850 and there are such a lot
of handlers processing this descriptor in data path. In order to have
generic data path, this patch introduces platform dependent handlers
in ath11k_hw_ops.

Tested-on: WCN6850 hw1.1 PCI WLAN.HSP.1.1-00687-QCAHSPSWPL_V1_SILICONZ-1

Signed-off-by: Baochen Qiang <bqiang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c    |  10 +-
 drivers/net/wireless/ath/ath11k/dp_rx.c   | 440 +++++++++++------------
 drivers/net/wireless/ath/ath11k/hal.h     |   2 -
 drivers/net/wireless/ath/ath11k/hw.c      | 555 ++++++++++++++++++++++++++++++
 drivers/net/wireless/ath/ath11k/hw.h      |  35 ++
 drivers/net/wireless/ath/ath11k/rx_desc.h | 136 +++++++-
 6 files changed, 930 insertions(+), 248 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 2d905a5..2555662 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -70,6 +70,8 @@ static const struct ath11k_hw_params ath11k_hw_params[] = {
 		.cold_boot_calib = true,
 		.supports_suspend = false,
 		.lmac_interrupt = true,
+
+		.hal_desc_sz = sizeof(struct hal_rx_desc_qca6390),
 	},
 	{
 		.hw_rev = ATH11K_HW_IPQ6018_HW10,
@@ -110,6 +112,8 @@ static const struct ath11k_hw_params ath11k_hw_params[] = {
 		.cold_boot_calib = true,
 		.supports_suspend = false,
 		.lmac_interrupt = true,
+
+		.hal_desc_sz = sizeof(struct hal_rx_desc_qca6390),
 	},
 	{
 		.name = "qca6390 hw2.0",
@@ -151,6 +155,8 @@ static const struct ath11k_hw_params ath11k_hw_params[] = {
 		.cold_boot_calib = false,
 		.supports_suspend = true,
 		.lmac_interrupt = false,
+
+		.hal_desc_sz = sizeof(struct hal_rx_desc_qca6390),
 	},
 	{
 		.name = "wcn6850 hw1.1",
@@ -162,7 +168,7 @@ static const struct ath11k_hw_params ath11k_hw_params[] = {
 		},
 		.max_radios = 3,
 		.bdf_addr = 0x4B0C0000,
-		.hw_ops = &qca6390_ops,
+		.hw_ops = &wcn6850_ops,
 		.ring_mask = &ath11k_hw_ring_mask_qca6390,
 		.internal_sleep_clock = true,
 		.regs = &wcn6850_regs,
@@ -192,6 +198,8 @@ static const struct ath11k_hw_params ath11k_hw_params[] = {
 		.cold_boot_calib = false,
 		.supports_suspend = true,
 		.lmac_interrupt = false,
+
+		.hal_desc_sz = sizeof(struct hal_rx_desc_wcn6850),
 	}
 };
 
diff --git a/drivers/net/wireless/ath/ath11k/dp_rx.c b/drivers/net/wireless/ath/ath11k/dp_rx.c
index 0ecdd7d..7229864 100644
--- a/drivers/net/wireless/ath/ath11k/dp_rx.c
+++ b/drivers/net/wireless/ath/ath11k/dp_rx.c
@@ -20,96 +20,87 @@
 
 #define ATH11K_DP_RX_FRAGMENT_TIMEOUT_MS (2 * HZ)
 
-static u8 *ath11k_dp_rx_h_80211_hdr(struct hal_rx_desc *desc)
+static u8 *ath11k_dp_rx_h_80211_hdr(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return desc->hdr_status;
+	return ab->hw_params.hw_ops->rxdesc_80211_hdr(desc);
 }
 
-static enum hal_encrypt_type ath11k_dp_rx_h_mpdu_start_enctype(struct hal_rx_desc *desc)
+static enum hal_encrypt_type ath11k_dp_rx_h_mpdu_start_enctype(struct ath11k_base *ab,
+							       struct hal_rx_desc *desc)
 {
-	if (!(__le32_to_cpu(desc->mpdu_start.info1) &
-	    RX_MPDU_START_INFO1_ENCRYPT_INFO_VALID))
-		return HAL_ENCRYPT_TYPE_OPEN;
-
-	return FIELD_GET(RX_MPDU_START_INFO2_ENC_TYPE,
-			 __le32_to_cpu(desc->mpdu_start.info2));
+	return ab->hw_params.hw_ops->rxdesc_mpdu_start_enctype(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_decap_type(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_decap_type(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO2_DECAP_FORMAT,
-			 __le32_to_cpu(desc->msdu_start.info2));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_decap_type(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_mesh_ctl_present(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_mesh_ctl_present(struct ath11k_base *ab,
+						     struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO2_MESH_CTRL_PRESENT,
-			 __le32_to_cpu(desc->msdu_start.info2));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_mesh_ctl_present(desc);
 }
 
-static bool ath11k_dp_rx_h_mpdu_start_seq_ctrl_valid(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_mpdu_start_seq_ctrl_valid(struct ath11k_base *ab,
+						     struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_MPDU_START_INFO1_MPDU_SEQ_CTRL_VALID,
-			   __le32_to_cpu(desc->mpdu_start.info1));
+	return ab->hw_params.hw_ops->rxdesc_mpdu_start_seq_ctrl_valid(desc);
 }
 
-static bool ath11k_dp_rx_h_mpdu_start_fc_valid(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_mpdu_start_fc_valid(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_MPDU_START_INFO1_MPDU_FCTRL_VALID,
-			   __le32_to_cpu(desc->mpdu_start.info1));
+	return ab->hw_params.hw_ops->rxdesc_mpdu_start_fc_valid(desc);
 }
 
-static bool ath11k_dp_rx_h_mpdu_start_more_frags(struct sk_buff *skb)
+static bool ath11k_dp_rx_h_mpdu_start_more_frags(struct ath11k_base *ab, struct sk_buff *skb)
 {
 	struct ieee80211_hdr *hdr;
 
-	hdr = (struct ieee80211_hdr *)(skb->data + HAL_RX_DESC_SIZE);
+	hdr = (struct ieee80211_hdr *)(skb->data + ab->hw_params.hal_desc_sz);
 	return ieee80211_has_morefrags(hdr->frame_control);
 }
 
-static u16 ath11k_dp_rx_h_mpdu_start_frag_no(struct sk_buff *skb)
+static u16 ath11k_dp_rx_h_mpdu_start_frag_no(struct ath11k_base *ab, struct sk_buff *skb)
 {
 	struct ieee80211_hdr *hdr;
 
-	hdr = (struct ieee80211_hdr *)(skb->data + HAL_RX_DESC_SIZE);
+	hdr = (struct ieee80211_hdr *)(skb->data + ab->hw_params.hal_desc_sz);
 	return le16_to_cpu(hdr->seq_ctrl) & IEEE80211_SCTL_FRAG;
 }
 
-static u16 ath11k_dp_rx_h_mpdu_start_seq_no(struct hal_rx_desc *desc)
+static u16 ath11k_dp_rx_h_mpdu_start_seq_no(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MPDU_START_INFO1_MPDU_SEQ_NUM,
-			 __le32_to_cpu(desc->mpdu_start.info1));
+	return ab->hw_params.hw_ops->rxdesc_mpdu_start_seq_no(desc);
 }
 
-static bool ath11k_dp_rx_h_attn_msdu_done(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_attn_msdu_done(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_ATTENTION_INFO2_MSDU_DONE,
-			   __le32_to_cpu(desc->attention.info2));
+	return ab->hw_params.hw_ops->rxdesc_attn_msdu_done(desc);
 }
 
-static bool ath11k_dp_rx_h_attn_l4_cksum_fail(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_attn_l4_cksum_fail(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_ATTENTION_INFO1_TCP_UDP_CKSUM_FAIL,
-			   __le32_to_cpu(desc->attention.info1));
+	return ab->hw_params.hw_ops->rxdesc_attn_l4_cksum_fail(desc);
 }
 
-static bool ath11k_dp_rx_h_attn_ip_cksum_fail(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_attn_ip_cksum_fail(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_ATTENTION_INFO1_IP_CKSUM_FAIL,
-			   __le32_to_cpu(desc->attention.info1));
+	return ab->hw_params.hw_ops->rxdesc_attn_ip_cksum_fail(desc);
 }
 
-static bool ath11k_dp_rx_h_attn_is_decrypted(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_attn_is_decrypted(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return (FIELD_GET(RX_ATTENTION_INFO2_DCRYPT_STATUS_CODE,
-			  __le32_to_cpu(desc->attention.info2)) ==
-		RX_DESC_DECRYPT_STATUS_CODE_OK);
+	return ab->hw_params.hw_ops->rxdesc_attn_is_decrypted(desc);
 }
 
-static u32 ath11k_dp_rx_h_attn_mpdu_err(struct hal_rx_desc *desc)
+static u32 ath11k_dp_rx_h_attn_mpdu_err(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	u32 info = __le32_to_cpu(desc->attention.info1);
-	u32 errmap = 0;
+	struct rx_attention *attn;
+	u32 info, errmap = 0;
+
+	attn = ab->hw_params.hw_ops->rxdesc_get_attn(desc);
+	info = __le32_to_cpu(attn->info1);
 
 	if (info & RX_ATTENTION_INFO1_FCS_ERR)
 		errmap |= DP_RX_MPDU_ERR_FCS;
@@ -135,131 +126,98 @@ static u32 ath11k_dp_rx_h_attn_mpdu_err(struct hal_rx_desc *desc)
 	return errmap;
 }
 
-static u16 ath11k_dp_rx_h_msdu_start_msdu_len(struct hal_rx_desc *desc)
+static u16 ath11k_dp_rx_h_msdu_start_msdu_len(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO1_MSDU_LENGTH,
-			 __le32_to_cpu(desc->msdu_start.info1));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_msdu_len(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_sgi(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_sgi(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO3_SGI,
-			 __le32_to_cpu(desc->msdu_start.info3));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_sgi(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_rate_mcs(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_rate_mcs(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO3_RATE_MCS,
-			 __le32_to_cpu(desc->msdu_start.info3));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_rate_mcs(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_rx_bw(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_rx_bw(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO3_RECV_BW,
-			 __le32_to_cpu(desc->msdu_start.info3));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_rx_bw(desc);
 }
 
-static u32 ath11k_dp_rx_h_msdu_start_freq(struct hal_rx_desc *desc)
+static u32 ath11k_dp_rx_h_msdu_start_freq(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return __le32_to_cpu(desc->msdu_start.phy_meta_data);
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_freq(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_pkt_type(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_pkt_type(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_START_INFO3_PKT_TYPE,
-			 __le32_to_cpu(desc->msdu_start.info3));
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_pkt_type(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_start_nss(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_start_nss(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	u8 mimo_ss_bitmap = FIELD_GET(RX_MSDU_START_INFO3_MIMO_SS_BITMAP,
-				      __le32_to_cpu(desc->msdu_start.info3));
+	u8 mimo_ss_bitmap;
 
+	mimo_ss_bitmap = ab->hw_params.hw_ops->rxdesc_msdu_start_nss(desc);
 	return hweight8(mimo_ss_bitmap);
 }
 
-static u8 ath11k_dp_rx_h_mpdu_start_tid(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_mpdu_start_tid(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MPDU_START_INFO2_TID,
-			 __le32_to_cpu(desc->mpdu_start.info2));
+	return ab->hw_params.hw_ops->rxdesc_mpdu_start_tid(desc);
 }
 
-static u16 ath11k_dp_rx_h_mpdu_start_peer_id(struct hal_rx_desc *desc)
+static u16 ath11k_dp_rx_h_mpdu_start_peer_id(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return __le16_to_cpu(desc->mpdu_start.sw_peer_id);
+	return ab->hw_params.hw_ops->rxdesc_mpdu_start_peer_id(desc);
 }
 
-static u8 ath11k_dp_rx_h_msdu_end_l3pad(struct hal_rx_desc *desc)
+static u8 ath11k_dp_rx_h_msdu_end_l3pad(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return FIELD_GET(RX_MSDU_END_INFO2_L3_HDR_PADDING,
-			 __le32_to_cpu(desc->msdu_end.info2));
+	return ab->hw_params.hw_ops->rxdesc_msdu_end_l3pad(desc);
 }
 
-static bool ath11k_dp_rx_h_msdu_end_first_msdu(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_msdu_end_first_msdu(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_MSDU_END_INFO2_FIRST_MSDU,
-			   __le32_to_cpu(desc->msdu_end.info2));
+	return ab->hw_params.hw_ops->rxdesc_msdu_end_first_msdu(desc);
 }
 
-static bool ath11k_dp_rx_h_msdu_end_last_msdu(struct hal_rx_desc *desc)
+static bool ath11k_dp_rx_h_msdu_end_last_msdu(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return !!FIELD_GET(RX_MSDU_END_INFO2_LAST_MSDU,
-			   __le32_to_cpu(desc->msdu_end.info2));
+	return ab->hw_params.hw_ops->rxdesc_msdu_end_last_msdu(desc);
 }
 
-static void ath11k_dp_rx_desc_end_tlv_copy(struct hal_rx_desc *fdesc,
-					   struct hal_rx_desc *ldesc)
+static void ath11k_dp_rxdesc_end_tlv_copy(struct ath11k_base *ab, struct hal_rx_desc *fdesc,
+					  struct hal_rx_desc *ldesc)
 {
-	memcpy((u8 *)&fdesc->msdu_end, (u8 *)&ldesc->msdu_end,
-	       sizeof(struct rx_msdu_end));
-	memcpy((u8 *)&fdesc->attention, (u8 *)&ldesc->attention,
-	       sizeof(struct rx_attention));
-	memcpy((u8 *)&fdesc->mpdu_end, (u8 *)&ldesc->mpdu_end,
-	       sizeof(struct rx_mpdu_end));
+	return ab->hw_params.hw_ops->rxdesc_end_tlv_copy(fdesc, ldesc);
 }
 
-static u32 ath11k_dp_rxdesc_get_mpdulen_err(struct hal_rx_desc *rx_desc)
+static u32 ath11k_dp_rxdesc_get_mpdulen_err(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	struct rx_attention *rx_attn;
-
-	rx_attn = &rx_desc->attention;
-
-	return FIELD_GET(RX_ATTENTION_INFO1_MPDU_LEN_ERR,
-			 __le32_to_cpu(rx_attn->info1));
+	return ab->hw_params.hw_ops->rxdesc_get_mpdulen_err(desc);
 }
 
-static u32 ath11k_dp_rxdesc_get_decap_format(struct hal_rx_desc *rx_desc)
+static u32 ath11k_dp_rxdesc_get_decap_format(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	struct rx_msdu_start *rx_msdu_start;
-
-	rx_msdu_start = &rx_desc->msdu_start;
-
-	return FIELD_GET(RX_MSDU_START_INFO2_DECAP_FORMAT,
-			 __le32_to_cpu(rx_msdu_start->info2));
+	return ab->hw_params.hw_ops->rxdesc_get_decap_format(desc);
 }
 
-static u8 *ath11k_dp_rxdesc_get_80211hdr(struct hal_rx_desc *rx_desc)
+static u8 *ath11k_dp_rxdesc_get_80211hdr(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	u8 *rx_pkt_hdr;
-
-	rx_pkt_hdr = &rx_desc->msdu_payload[0];
-
-	return rx_pkt_hdr;
+	return ab->hw_params.hw_ops->rxdesc_get_80211hdr(desc);
 }
 
-static bool ath11k_dp_rxdesc_mpdu_valid(struct hal_rx_desc *rx_desc)
+static bool ath11k_dp_rxdesc_mpdu_valid(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	u32 tlv_tag;
-
-	tlv_tag = FIELD_GET(HAL_TLV_HDR_TAG,
-			    __le32_to_cpu(rx_desc->mpdu_start_tag));
-
-	return tlv_tag == HAL_RX_MPDU_START;
+	return ab->hw_params.hw_ops->rxdesc_mpdu_valid(desc);
 }
 
-static u32 ath11k_dp_rxdesc_get_ppduid(struct hal_rx_desc *rx_desc)
+static u32 ath11k_dp_rxdesc_get_ppduid(struct ath11k_base *ab, struct hal_rx_desc *desc)
 {
-	return __le16_to_cpu(rx_desc->mpdu_start.phy_ppdu_id);
+	return ab->hw_params.hw_ops->rxdesc_get_ppduid(desc);
 }
 
 static void ath11k_dp_service_mon_ring(struct timer_list *t)
@@ -1700,6 +1658,7 @@ static int ath11k_dp_rx_msdu_coalesce(struct ath11k *ar,
 				      struct sk_buff *first, struct sk_buff *last,
 				      u8 l3pad_bytes, int msdu_len)
 {
+	struct ath11k_base *ab = ar->ab;
 	struct sk_buff *skb;
 	struct ath11k_skb_rxcb *rxcb = ATH11K_SKB_RXCB(first);
 	int buf_first_hdr_len, buf_first_len;
@@ -1712,7 +1671,7 @@ static int ath11k_dp_rx_msdu_coalesce(struct ath11k *ar,
 	 * find the offset to the start of msdu for computing
 	 * the length of the msdu in the first buffer.
 	 */
-	buf_first_hdr_len = HAL_RX_DESC_SIZE + l3pad_bytes;
+	buf_first_hdr_len = ab->hw_params.hal_desc_sz + l3pad_bytes;
 	buf_first_len = DP_RX_BUFFER_SIZE - buf_first_hdr_len;
 
 	if (WARN_ON_ONCE(msdu_len <= buf_first_len)) {
@@ -1722,12 +1681,12 @@ static int ath11k_dp_rx_msdu_coalesce(struct ath11k *ar,
 	}
 
 	ldesc = (struct hal_rx_desc *)last->data;
-	rxcb->is_first_msdu = ath11k_dp_rx_h_msdu_end_first_msdu(ldesc);
-	rxcb->is_last_msdu = ath11k_dp_rx_h_msdu_end_last_msdu(ldesc);
+	rxcb->is_first_msdu = ath11k_dp_rx_h_msdu_end_first_msdu(ab, ldesc);
+	rxcb->is_last_msdu = ath11k_dp_rx_h_msdu_end_last_msdu(ab, ldesc);
 
 	/* MSDU spans over multiple buffers because the length of the MSDU
-	 * exceeds DP_RX_BUFFER_SIZE - HAL_RX_DESC_SIZE. So assume the data
-	 * in the first buf is of length DP_RX_BUFFER_SIZE - HAL_RX_DESC_SIZE.
+	 * exceeds DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz. So assume the data
+	 * in the first buf is of length DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz.
 	 */
 	skb_put(first, DP_RX_BUFFER_SIZE);
 	skb_pull(first, buf_first_hdr_len);
@@ -1735,7 +1694,7 @@ static int ath11k_dp_rx_msdu_coalesce(struct ath11k *ar,
 	/* When an MSDU spread over multiple buffers attention, MSDU_END and
 	 * MPDU_END tlvs are valid only in the last buffer. Copy those tlvs.
 	 */
-	ath11k_dp_rx_desc_end_tlv_copy(rxcb->rx_desc, ldesc);
+	ath11k_dp_rxdesc_end_tlv_copy(ab, rxcb->rx_desc, ldesc);
 
 	space_extra = msdu_len - (buf_first_len + skb_tailroom(first));
 	if (space_extra > 0 &&
@@ -1756,18 +1715,18 @@ static int ath11k_dp_rx_msdu_coalesce(struct ath11k *ar,
 	while ((skb = __skb_dequeue(msdu_list)) != NULL && rem_len > 0) {
 		rxcb = ATH11K_SKB_RXCB(skb);
 		if (rxcb->is_continuation)
-			buf_len = DP_RX_BUFFER_SIZE - HAL_RX_DESC_SIZE;
+			buf_len = DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz;
 		else
 			buf_len = rem_len;
 
-		if (buf_len > (DP_RX_BUFFER_SIZE - HAL_RX_DESC_SIZE)) {
+		if (buf_len > (DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz)) {
 			WARN_ON_ONCE(1);
 			dev_kfree_skb_any(skb);
 			return -EINVAL;
 		}
 
-		skb_put(skb, buf_len + HAL_RX_DESC_SIZE);
-		skb_pull(skb, HAL_RX_DESC_SIZE);
+		skb_put(skb, buf_len + ab->hw_params.hal_desc_sz);
+		skb_pull(skb, ab->hw_params.hal_desc_sz);
 		skb_copy_from_linear_data(skb, skb_put(first, buf_len),
 					  buf_len);
 		dev_kfree_skb_any(skb);
@@ -1798,13 +1757,13 @@ static struct sk_buff *ath11k_dp_rx_get_msdu_last_buf(struct sk_buff_head *msdu_
 	return NULL;
 }
 
-static void ath11k_dp_rx_h_csum_offload(struct sk_buff *msdu)
+static void ath11k_dp_rx_h_csum_offload(struct ath11k_base *ab, struct sk_buff *msdu)
 {
 	struct ath11k_skb_rxcb *rxcb = ATH11K_SKB_RXCB(msdu);
 	bool ip_csum_fail, l4_csum_fail;
 
-	ip_csum_fail = ath11k_dp_rx_h_attn_ip_cksum_fail(rxcb->rx_desc);
-	l4_csum_fail = ath11k_dp_rx_h_attn_l4_cksum_fail(rxcb->rx_desc);
+	ip_csum_fail = ath11k_dp_rx_h_attn_ip_cksum_fail(ab, rxcb->rx_desc);
+	l4_csum_fail = ath11k_dp_rx_h_attn_l4_cksum_fail(ab, rxcb->rx_desc);
 
 	msdu->ip_summed = (ip_csum_fail || l4_csum_fail) ?
 			  CHECKSUM_NONE : CHECKSUM_UNNECESSARY;
@@ -1935,7 +1894,7 @@ static void ath11k_dp_rx_h_undecap_nwifi(struct ath11k *ar,
 
 		qos_ctl = rxcb->tid;
 
-		if (ath11k_dp_rx_h_msdu_start_mesh_ctl_present(rxcb->rx_desc))
+		if (ath11k_dp_rx_h_msdu_start_mesh_ctl_present(ar->ab, rxcb->rx_desc))
 			qos_ctl |= IEEE80211_QOS_CTL_MESH_CONTROL_PRESENT;
 
 		/* TODO Add other QoS ctl fields when required */
@@ -2039,7 +1998,7 @@ static void *ath11k_dp_rx_h_find_rfc1042(struct ath11k *ar,
 	bool is_amsdu;
 
 	is_amsdu = !(rxcb->is_first_msdu && rxcb->is_last_msdu);
-	hdr = (struct ieee80211_hdr *)ath11k_dp_rx_h_80211_hdr(rxcb->rx_desc);
+	hdr = (struct ieee80211_hdr *)ath11k_dp_rx_h_80211_hdr(ar->ab, rxcb->rx_desc);
 	rfc1042 = hdr;
 
 	if (rxcb->is_first_msdu) {
@@ -2112,8 +2071,8 @@ static void ath11k_dp_rx_h_undecap(struct ath11k *ar, struct sk_buff *msdu,
 	u8 *first_hdr;
 	u8 decap;
 
-	first_hdr = ath11k_dp_rx_h_80211_hdr(rx_desc);
-	decap = ath11k_dp_rx_h_msdu_start_decap_type(rx_desc);
+	first_hdr = ath11k_dp_rx_h_80211_hdr(ar->ab, rx_desc);
+	decap = ath11k_dp_rx_h_msdu_start_decap_type(ar->ab, rx_desc);
 
 	switch (decap) {
 	case DP_RX_DECAP_TYPE_NATIVE_WIFI:
@@ -2166,9 +2125,9 @@ static void ath11k_dp_rx_h_mpdu(struct ath11k *ar,
 	}
 	spin_unlock_bh(&ar->ab->base_lock);
 
-	err_bitmap = ath11k_dp_rx_h_attn_mpdu_err(rx_desc);
+	err_bitmap = ath11k_dp_rx_h_attn_mpdu_err(ar->ab, rx_desc);
 	if (enctype != HAL_ENCRYPT_TYPE_OPEN && !err_bitmap)
-		is_decrypted = ath11k_dp_rx_h_attn_is_decrypted(rx_desc);
+		is_decrypted = ath11k_dp_rx_h_attn_is_decrypted(ar->ab, rx_desc);
 
 	/* Clear per-MPDU flags while leaving per-PPDU flags intact */
 	rx_status->flag &= ~(RX_FLAG_FAILED_FCS_CRC |
@@ -2193,7 +2152,7 @@ static void ath11k_dp_rx_h_mpdu(struct ath11k *ar,
 					   RX_FLAG_PN_VALIDATED;
 	}
 
-	ath11k_dp_rx_h_csum_offload(msdu);
+	ath11k_dp_rx_h_csum_offload(ar->ab, msdu);
 	ath11k_dp_rx_h_undecap(ar, msdu, rx_desc,
 			       enctype, rx_status, is_decrypted);
 
@@ -2214,11 +2173,11 @@ static void ath11k_dp_rx_h_rate(struct ath11k *ar, struct hal_rx_desc *rx_desc,
 	u8 sgi;
 	bool is_cck;
 
-	pkt_type = ath11k_dp_rx_h_msdu_start_pkt_type(rx_desc);
-	bw = ath11k_dp_rx_h_msdu_start_rx_bw(rx_desc);
-	rate_mcs = ath11k_dp_rx_h_msdu_start_rate_mcs(rx_desc);
-	nss = ath11k_dp_rx_h_msdu_start_nss(rx_desc);
-	sgi = ath11k_dp_rx_h_msdu_start_sgi(rx_desc);
+	pkt_type = ath11k_dp_rx_h_msdu_start_pkt_type(ar->ab, rx_desc);
+	bw = ath11k_dp_rx_h_msdu_start_rx_bw(ar->ab, rx_desc);
+	rate_mcs = ath11k_dp_rx_h_msdu_start_rate_mcs(ar->ab, rx_desc);
+	nss = ath11k_dp_rx_h_msdu_start_nss(ar->ab, rx_desc);
+	sgi = ath11k_dp_rx_h_msdu_start_sgi(ar->ab, rx_desc);
 
 	switch (pkt_type) {
 	case RX_MSDU_START_PKT_TYPE_11A:
@@ -2277,6 +2236,7 @@ static void ath11k_dp_rx_h_ppdu(struct ath11k *ar, struct hal_rx_desc *rx_desc,
 	u8 channel_num;
 	u32 center_freq;
 	struct ieee80211_channel *channel;
+	struct ath11k_base *ab = ar->ab;
 
 	rx_status->freq = 0;
 	rx_status->rate_idx = 0;
@@ -2286,8 +2246,8 @@ static void ath11k_dp_rx_h_ppdu(struct ath11k *ar, struct hal_rx_desc *rx_desc,
 
 	rx_status->flag |= RX_FLAG_NO_SIGNAL_VAL;
 
-	channel_num = ath11k_dp_rx_h_msdu_start_freq(rx_desc);
-	center_freq = ath11k_dp_rx_h_msdu_start_freq(rx_desc) >> 16;
+	channel_num = ath11k_dp_rx_h_msdu_start_freq(ar->ab, rx_desc);
+	center_freq = ath11k_dp_rx_h_msdu_start_freq(ar->ab, rx_desc) >> 16;
 
 	if (center_freq >= ATH11K_MIN_6G_FREQ && center_freq <= ATH11K_MAX_6G_FREQ) {
 		rx_status->band = NL80211_BAND_6GHZ;
@@ -2305,7 +2265,7 @@ static void ath11k_dp_rx_h_ppdu(struct ath11k *ar, struct hal_rx_desc *rx_desc,
 		}
 		spin_unlock_bh(&ar->data_lock);
 		ath11k_dbg_dump(ar->ab, ATH11K_DBG_DATA, NULL, "rx_desc: ",
-				rx_desc, sizeof(struct hal_rx_desc));
+				rx_desc, ab->hw_params.hal_desc_sz);
 	}
 
 	rx_status->freq = ieee80211_channel_to_frequency(channel_num,
@@ -2400,6 +2360,7 @@ static int ath11k_dp_rx_process_msdu(struct ath11k *ar,
 	u8 *hdr_status;
 	u16 msdu_len;
 	int ret;
+	struct ath11k_base *ab = ar->ab;
 
 	last_buf = ath11k_dp_rx_get_msdu_last_buf(msdu_list, msdu);
 	if (!last_buf) {
@@ -2411,7 +2372,7 @@ static int ath11k_dp_rx_process_msdu(struct ath11k *ar,
 
 	rx_desc = (struct hal_rx_desc *)msdu->data;
 	lrx_desc = (struct hal_rx_desc *)last_buf->data;
-	if (!ath11k_dp_rx_h_attn_msdu_done(lrx_desc)) {
+	if (!ath11k_dp_rx_h_attn_msdu_done(ab, lrx_desc)) {
 		ath11k_warn(ar->ab, "msdu_done bit in attention is not set\n");
 		ret = -EIO;
 		goto free_out;
@@ -2419,24 +2380,24 @@ static int ath11k_dp_rx_process_msdu(struct ath11k *ar,
 
 	rxcb = ATH11K_SKB_RXCB(msdu);
 	rxcb->rx_desc = rx_desc;
-	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(rx_desc);
-	l3_pad_bytes = ath11k_dp_rx_h_msdu_end_l3pad(lrx_desc);
+	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(ab, rx_desc);
+	l3_pad_bytes = ath11k_dp_rx_h_msdu_end_l3pad(ab, lrx_desc);
 
 	if (rxcb->is_frag) {
-		skb_pull(msdu, HAL_RX_DESC_SIZE);
+		skb_pull(msdu, ab->hw_params.hal_desc_sz);
 	} else if (!rxcb->is_continuation) {
-		if ((msdu_len + HAL_RX_DESC_SIZE) > DP_RX_BUFFER_SIZE) {
-			hdr_status = ath11k_dp_rx_h_80211_hdr(rx_desc);
+		if ((msdu_len + ab->hw_params.hal_desc_sz) > DP_RX_BUFFER_SIZE) {
+			hdr_status = ath11k_dp_rx_h_80211_hdr(ab, rx_desc);
 			ret = -EINVAL;
 			ath11k_warn(ar->ab, "invalid msdu len %u\n", msdu_len);
 			ath11k_dbg_dump(ar->ab, ATH11K_DBG_DATA, NULL, "", hdr_status,
 					sizeof(struct ieee80211_hdr));
 			ath11k_dbg_dump(ar->ab, ATH11K_DBG_DATA, NULL, "", rx_desc,
-					sizeof(struct hal_rx_desc));
+					ab->hw_params.hal_desc_sz);
 			goto free_out;
 		}
-		skb_put(msdu, HAL_RX_DESC_SIZE + l3_pad_bytes + msdu_len);
-		skb_pull(msdu, HAL_RX_DESC_SIZE + l3_pad_bytes);
+		skb_put(msdu, ab->hw_params.hal_desc_sz + l3_pad_bytes + msdu_len);
+		skb_pull(msdu, ab->hw_params.hal_desc_sz + l3_pad_bytes);
 	} else {
 		ret = ath11k_dp_rx_msdu_coalesce(ar, msdu_list,
 						 msdu, last_buf,
@@ -3082,13 +3043,14 @@ static int ath11k_dp_rx_h_verify_tkip_mic(struct ath11k *ar, struct ath11k_peer
 	u32 hdr_len;
 	u8 *key, *data;
 	u8 key_idx;
+	struct ath11k_base *ab = ar->ab;
 
-	if (ath11k_dp_rx_h_mpdu_start_enctype(rx_desc) != HAL_ENCRYPT_TYPE_TKIP_MIC)
+	if (ath11k_dp_rx_h_mpdu_start_enctype(ab, rx_desc) != HAL_ENCRYPT_TYPE_TKIP_MIC)
 		return 0;
 
-	hdr = (struct ieee80211_hdr *)(msdu->data + HAL_RX_DESC_SIZE);
+	hdr = (struct ieee80211_hdr *)(msdu->data + ab->hw_params.hal_desc_sz);
 	hdr_len = ieee80211_hdrlen(hdr->frame_control);
-	head_len = hdr_len + HAL_RX_DESC_SIZE + IEEE80211_TKIP_IV_LEN;
+	head_len = hdr_len + ab->hw_params.hal_desc_sz + IEEE80211_TKIP_IV_LEN;
 	tail_len = IEEE80211_CCMP_MIC_LEN + IEEE80211_TKIP_ICV_LEN + FCS_LEN;
 
 	if (!is_multicast_ether_addr(hdr->addr1))
@@ -3114,7 +3076,7 @@ static int ath11k_dp_rx_h_verify_tkip_mic(struct ath11k *ar, struct ath11k_peer
 
 	rxs->flag |= RX_FLAG_MMIC_ERROR | RX_FLAG_MMIC_STRIPPED |
 		    RX_FLAG_IV_STRIPPED | RX_FLAG_DECRYPTED;
-	skb_pull(msdu, HAL_RX_DESC_SIZE);
+	skb_pull(msdu, ab->hw_params.hal_desc_sz);
 
 	ath11k_dp_rx_h_ppdu(ar, rx_desc, rxs);
 	ath11k_dp_rx_h_undecap(ar, msdu, rx_desc,
@@ -3129,11 +3091,12 @@ static void ath11k_dp_rx_h_undecap_frag(struct ath11k *ar, struct sk_buff *msdu,
 	struct ieee80211_hdr *hdr;
 	size_t hdr_len;
 	size_t crypto_len;
+	struct ath11k_base *ab = ar->ab;
 
 	if (!flags)
 		return;
 
-	hdr = (struct ieee80211_hdr *)(msdu->data + HAL_RX_DESC_SIZE);
+	hdr = (struct ieee80211_hdr *)(msdu->data + ab->hw_params.hal_desc_sz);
 
 	if (flags & RX_FLAG_MIC_STRIPPED)
 		skb_trim(msdu, msdu->len -
@@ -3147,8 +3110,8 @@ static void ath11k_dp_rx_h_undecap_frag(struct ath11k *ar, struct sk_buff *msdu,
 		hdr_len = ieee80211_hdrlen(hdr->frame_control);
 		crypto_len = ath11k_dp_rx_crypto_param_len(ar, enctype);
 
-		memmove((void *)msdu->data + HAL_RX_DESC_SIZE + crypto_len,
-			(void *)msdu->data + HAL_RX_DESC_SIZE, hdr_len);
+		memmove((void *)msdu->data + ab->hw_params.hal_desc_sz + crypto_len,
+			(void *)msdu->data + ab->hw_params.hal_desc_sz, hdr_len);
 		skb_pull(msdu, crypto_len);
 	}
 }
@@ -3166,6 +3129,7 @@ static int ath11k_dp_rx_h_defrag(struct ath11k *ar,
 	int msdu_len = 0;
 	int extra_space;
 	u32 flags;
+	struct ath11k_base *ab = ar->ab;
 
 	first_frag = skb_peek(&rx_tid->rx_frags);
 	last_frag = skb_peek_tail(&rx_tid->rx_frags);
@@ -3173,11 +3137,11 @@ static int ath11k_dp_rx_h_defrag(struct ath11k *ar,
 	skb_queue_walk(&rx_tid->rx_frags, skb) {
 		flags = 0;
 		rx_desc = (struct hal_rx_desc *)skb->data;
-		hdr = (struct ieee80211_hdr *)(skb->data + HAL_RX_DESC_SIZE);
+		hdr = (struct ieee80211_hdr *)(skb->data + ab->hw_params.hal_desc_sz);
 
-		enctype = ath11k_dp_rx_h_mpdu_start_enctype(rx_desc);
+		enctype = ath11k_dp_rx_h_mpdu_start_enctype(ab, rx_desc);
 		if (enctype != HAL_ENCRYPT_TYPE_OPEN)
-			is_decrypted = ath11k_dp_rx_h_attn_is_decrypted(rx_desc);
+			is_decrypted = ath11k_dp_rx_h_attn_is_decrypted(ab, rx_desc);
 
 		if (is_decrypted) {
 			if (skb != first_frag)
@@ -3193,7 +3157,7 @@ static int ath11k_dp_rx_h_defrag(struct ath11k *ar,
 		ath11k_dp_rx_h_undecap_frag(ar, skb, enctype, flags);
 
 		if (skb != first_frag)
-			skb_pull(skb, HAL_RX_DESC_SIZE +
+			skb_pull(skb, ab->hw_params.hal_desc_sz +
 				      ieee80211_hdrlen(hdr->frame_control));
 		msdu_len += skb->len;
 	}
@@ -3209,7 +3173,7 @@ static int ath11k_dp_rx_h_defrag(struct ath11k *ar,
 		dev_kfree_skb_any(skb);
 	}
 
-	hdr = (struct ieee80211_hdr *)(first_frag->data + HAL_RX_DESC_SIZE);
+	hdr = (struct ieee80211_hdr *)(first_frag->data + ab->hw_params.hal_desc_sz);
 	hdr->frame_control &= ~__cpu_to_le16(IEEE80211_FCTL_MOREFRAGS);
 	ATH11K_SKB_RXCB(first_frag)->is_frag = 1;
 
@@ -3220,6 +3184,12 @@ static int ath11k_dp_rx_h_defrag(struct ath11k *ar,
 	return 0;
 }
 
+static u32 *ath11k_dp_rx_h_msdu_start_msdu_len_offset(struct ath11k_base *ab,
+						      struct hal_rx_desc *desc)
+{
+	return ab->hw_params.hw_ops->rxdesc_msdu_start_msdu_len_offset(desc);
+}
+
 static int ath11k_dp_rx_h_defrag_reo_reinject(struct ath11k *ar, struct dp_rx_tid *rx_tid,
 					      struct sk_buff *defrag_skb)
 {
@@ -3253,16 +3223,16 @@ static int ath11k_dp_rx_h_defrag_reo_reinject(struct ath11k *ar, struct dp_rx_ti
 		    FIELD_PREP(RX_MSDU_DESC_INFO0_LAST_MSDU_IN_MPDU, 1) |
 		    FIELD_PREP(RX_MSDU_DESC_INFO0_MSDU_CONTINUATION, 0) |
 		    FIELD_PREP(RX_MSDU_DESC_INFO0_MSDU_LENGTH,
-			       defrag_skb->len - HAL_RX_DESC_SIZE) |
+			       defrag_skb->len - ab->hw_params.hal_desc_sz) |
 		    FIELD_PREP(RX_MSDU_DESC_INFO0_REO_DEST_IND, dst_idx) |
 		    FIELD_PREP(RX_MSDU_DESC_INFO0_VALID_SA, 1) |
 		    FIELD_PREP(RX_MSDU_DESC_INFO0_VALID_DA, 1);
 	msdu0->rx_msdu_info.info0 = msdu_info;
 
 	/* change msdu len in hal rx desc */
-	msdu_len_offset = (u32 *)&rx_desc->msdu_start;
+	msdu_len_offset = ath11k_dp_rx_h_msdu_start_msdu_len_offset(ab, rx_desc);
 	*msdu_len_offset &= ~(RX_MSDU_START_INFO1_MSDU_LENGTH);
-	*msdu_len_offset |= defrag_skb->len - HAL_RX_DESC_SIZE;
+	*msdu_len_offset |= defrag_skb->len - ab->hw_params.hal_desc_sz;
 
 	paddr = dma_map_single(ab->dev, defrag_skb->data,
 			       defrag_skb->len + skb_tailroom(defrag_skb),
@@ -3335,24 +3305,24 @@ static int ath11k_dp_rx_h_defrag_reo_reinject(struct ath11k *ar, struct dp_rx_ti
 	return ret;
 }
 
-static int ath11k_dp_rx_h_cmp_frags(struct sk_buff *a, struct sk_buff *b)
+static int ath11k_dp_rx_h_cmp_frags(struct ath11k_base *ab, struct sk_buff *a, struct sk_buff *b)
 {
 	int frag1, frag2;
 
-	frag1 = ath11k_dp_rx_h_mpdu_start_frag_no(a);
-	frag2 = ath11k_dp_rx_h_mpdu_start_frag_no(b);
+	frag1 = ath11k_dp_rx_h_mpdu_start_frag_no(ab, a);
+	frag2 = ath11k_dp_rx_h_mpdu_start_frag_no(ab, b);
 
 	return frag1 - frag2;
 }
 
-static void ath11k_dp_rx_h_sort_frags(struct sk_buff_head *frag_list,
+static void ath11k_dp_rx_h_sort_frags(struct ath11k_base *ab, struct sk_buff_head *frag_list,
 				      struct sk_buff *cur_frag)
 {
 	struct sk_buff *skb;
 	int cmp;
 
 	skb_queue_walk(frag_list, skb) {
-		cmp = ath11k_dp_rx_h_cmp_frags(skb, cur_frag);
+		cmp = ath11k_dp_rx_h_cmp_frags(ab, skb, cur_frag);
 		if (cmp < 0)
 			continue;
 		__skb_queue_before(frag_list, skb, cur_frag);
@@ -3361,14 +3331,14 @@ static void ath11k_dp_rx_h_sort_frags(struct sk_buff_head *frag_list,
 	__skb_queue_tail(frag_list, cur_frag);
 }
 
-static u64 ath11k_dp_rx_h_get_pn(struct sk_buff *skb)
+static u64 ath11k_dp_rx_h_get_pn(struct ath11k_base *ab, struct sk_buff *skb)
 {
 	struct ieee80211_hdr *hdr;
 	u64 pn = 0;
 	u8 *ehdr;
 
-	hdr = (struct ieee80211_hdr *)(skb->data + HAL_RX_DESC_SIZE);
-	ehdr = skb->data + HAL_RX_DESC_SIZE + ieee80211_hdrlen(hdr->frame_control);
+	hdr = (struct ieee80211_hdr *)(skb->data + ab->hw_params.hal_desc_sz);
+	ehdr = skb->data + ab->hw_params.hal_desc_sz + ieee80211_hdrlen(hdr->frame_control);
 
 	pn = ehdr[0];
 	pn |= (u64)ehdr[1] << 8;
@@ -3392,19 +3362,19 @@ ath11k_dp_rx_h_defrag_validate_incr_pn(struct ath11k *ar, struct dp_rx_tid *rx_t
 	first_frag = skb_peek(&rx_tid->rx_frags);
 	desc = (struct hal_rx_desc *)first_frag->data;
 
-	encrypt_type = ath11k_dp_rx_h_mpdu_start_enctype(desc);
+	encrypt_type = ath11k_dp_rx_h_mpdu_start_enctype(ar->ab, desc);
 	if (encrypt_type != HAL_ENCRYPT_TYPE_CCMP_128 &&
 	    encrypt_type != HAL_ENCRYPT_TYPE_CCMP_256 &&
 	    encrypt_type != HAL_ENCRYPT_TYPE_GCMP_128 &&
 	    encrypt_type != HAL_ENCRYPT_TYPE_AES_GCMP_256)
 		return true;
 
-	last_pn = ath11k_dp_rx_h_get_pn(first_frag);
+	last_pn = ath11k_dp_rx_h_get_pn(ar->ab, first_frag);
 	skb_queue_walk(&rx_tid->rx_frags, skb) {
 		if (skb == first_frag)
 			continue;
 
-		cur_pn = ath11k_dp_rx_h_get_pn(skb);
+		cur_pn = ath11k_dp_rx_h_get_pn(ar->ab, skb);
 		if (cur_pn != last_pn + 1)
 			return false;
 		last_pn = cur_pn;
@@ -3428,14 +3398,14 @@ static int ath11k_dp_rx_frag_h_mpdu(struct ath11k *ar,
 	bool more_frags;
 
 	rx_desc = (struct hal_rx_desc *)msdu->data;
-	peer_id = ath11k_dp_rx_h_mpdu_start_peer_id(rx_desc);
-	tid = ath11k_dp_rx_h_mpdu_start_tid(rx_desc);
-	seqno = ath11k_dp_rx_h_mpdu_start_seq_no(rx_desc);
-	frag_no = ath11k_dp_rx_h_mpdu_start_frag_no(msdu);
-	more_frags = ath11k_dp_rx_h_mpdu_start_more_frags(msdu);
-
-	if (!ath11k_dp_rx_h_mpdu_start_seq_ctrl_valid(rx_desc) ||
-	    !ath11k_dp_rx_h_mpdu_start_fc_valid(rx_desc) ||
+	peer_id = ath11k_dp_rx_h_mpdu_start_peer_id(ab, rx_desc);
+	tid = ath11k_dp_rx_h_mpdu_start_tid(ab, rx_desc);
+	seqno = ath11k_dp_rx_h_mpdu_start_seq_no(ab, rx_desc);
+	frag_no = ath11k_dp_rx_h_mpdu_start_frag_no(ab, msdu);
+	more_frags = ath11k_dp_rx_h_mpdu_start_more_frags(ab, msdu);
+
+	if (!ath11k_dp_rx_h_mpdu_start_seq_ctrl_valid(ab, rx_desc) ||
+	    !ath11k_dp_rx_h_mpdu_start_fc_valid(ab, rx_desc) ||
 	    tid > IEEE80211_NUM_TIDS)
 		return -EINVAL;
 
@@ -3473,7 +3443,7 @@ static int ath11k_dp_rx_frag_h_mpdu(struct ath11k *ar,
 	if (frag_no > __fls(rx_tid->rx_frag_bitmap))
 		__skb_queue_tail(&rx_tid->rx_frags, msdu);
 	else
-		ath11k_dp_rx_h_sort_frags(&rx_tid->rx_frags, msdu);
+		ath11k_dp_rx_h_sort_frags(ar->ab, &rx_tid->rx_frags, msdu);
 
 	rx_tid->rx_frag_bitmap |= BIT(frag_no);
 	if (!more_frags)
@@ -3540,6 +3510,7 @@ ath11k_dp_process_rx_err_buf(struct ath11k *ar, u32 *ring_desc, int buf_id, bool
 	struct hal_rx_desc *rx_desc;
 	u8 *hdr_status;
 	u16 msdu_len;
+	struct ath11k_base *ab = ar->ab;
 
 	spin_lock_bh(&rx_ring->idr_lock);
 	msdu = idr_find(&rx_ring->bufs_idr, buf_id);
@@ -3575,19 +3546,19 @@ ath11k_dp_process_rx_err_buf(struct ath11k *ar, u32 *ring_desc, int buf_id, bool
 	}
 
 	rx_desc = (struct hal_rx_desc *)msdu->data;
-	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(rx_desc);
-	if ((msdu_len + HAL_RX_DESC_SIZE) > DP_RX_BUFFER_SIZE) {
-		hdr_status = ath11k_dp_rx_h_80211_hdr(rx_desc);
+	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(ab, rx_desc);
+	if ((msdu_len + ab->hw_params.hal_desc_sz) > DP_RX_BUFFER_SIZE) {
+		hdr_status = ath11k_dp_rx_h_80211_hdr(ab, rx_desc);
 		ath11k_warn(ar->ab, "invalid msdu leng %u", msdu_len);
 		ath11k_dbg_dump(ar->ab, ATH11K_DBG_DATA, NULL, "", hdr_status,
 				sizeof(struct ieee80211_hdr));
 		ath11k_dbg_dump(ar->ab, ATH11K_DBG_DATA, NULL, "", rx_desc,
-				sizeof(struct hal_rx_desc));
+				ab->hw_params.hal_desc_sz);
 		dev_kfree_skb_any(msdu);
 		goto exit;
 	}
 
-	skb_put(msdu, HAL_RX_DESC_SIZE + msdu_len);
+	skb_put(msdu, ab->hw_params.hal_desc_sz + msdu_len);
 
 	if (ath11k_dp_rx_frag_h_mpdu(ar, msdu, ring_desc)) {
 		dev_kfree_skb_any(msdu);
@@ -3719,9 +3690,10 @@ static void ath11k_dp_rx_null_q_desc_sg_drop(struct ath11k *ar,
 	struct sk_buff *skb, *tmp;
 	struct ath11k_skb_rxcb *rxcb;
 	int n_buffs;
+	struct ath11k_base *ab = ar->ab;
 
 	n_buffs = DIV_ROUND_UP(msdu_len,
-			       (DP_RX_BUFFER_SIZE - HAL_RX_DESC_SIZE));
+			       (DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz));
 
 	skb_queue_walk_safe(msdu_list, skb, tmp) {
 		rxcb = ATH11K_SKB_RXCB(skb);
@@ -3741,20 +3713,21 @@ static int ath11k_dp_rx_h_null_q_desc(struct ath11k *ar, struct sk_buff *msdu,
 				      struct sk_buff_head *msdu_list)
 {
 	u16 msdu_len;
+	struct ath11k_base *ab = ar->ab;
 	struct hal_rx_desc *desc = (struct hal_rx_desc *)msdu->data;
 	u8 l3pad_bytes;
 	struct ath11k_skb_rxcb *rxcb = ATH11K_SKB_RXCB(msdu);
 
-	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(desc);
+	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(ab, desc);
 
-	if (!rxcb->is_frag && ((msdu_len + HAL_RX_DESC_SIZE) > DP_RX_BUFFER_SIZE)) {
+	if (!rxcb->is_frag && ((msdu_len + ab->hw_params.hal_desc_sz) > DP_RX_BUFFER_SIZE)) {
 		/* First buffer will be freed by the caller, so deduct it's length */
-		msdu_len = msdu_len - (DP_RX_BUFFER_SIZE - HAL_RX_DESC_SIZE);
+		msdu_len = msdu_len - (DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz);
 		ath11k_dp_rx_null_q_desc_sg_drop(ar, msdu_len, msdu_list);
 		return -EINVAL;
 	}
 
-	if (!ath11k_dp_rx_h_attn_msdu_done(desc)) {
+	if (!ath11k_dp_rx_h_attn_msdu_done(ab, desc)) {
 		ath11k_warn(ar->ab,
 			    "msdu_done bit not set in null_q_des processing\n");
 		__skb_queue_purge(msdu_list);
@@ -3770,25 +3743,25 @@ static int ath11k_dp_rx_h_null_q_desc(struct ath11k *ar, struct sk_buff *msdu,
 	 * This error can show up both in a REO destination or WBM release ring.
 	 */
 
-	rxcb->is_first_msdu = ath11k_dp_rx_h_msdu_end_first_msdu(desc);
-	rxcb->is_last_msdu = ath11k_dp_rx_h_msdu_end_last_msdu(desc);
+	rxcb->is_first_msdu = ath11k_dp_rx_h_msdu_end_first_msdu(ab, desc);
+	rxcb->is_last_msdu = ath11k_dp_rx_h_msdu_end_last_msdu(ab, desc);
 
 	if (rxcb->is_frag) {
-		skb_pull(msdu, HAL_RX_DESC_SIZE);
+		skb_pull(msdu, ab->hw_params.hal_desc_sz);
 	} else {
-		l3pad_bytes = ath11k_dp_rx_h_msdu_end_l3pad(desc);
+		l3pad_bytes = ath11k_dp_rx_h_msdu_end_l3pad(ab, desc);
 
-		if ((HAL_RX_DESC_SIZE + l3pad_bytes + msdu_len) > DP_RX_BUFFER_SIZE)
+		if ((ab->hw_params.hal_desc_sz + l3pad_bytes + msdu_len) > DP_RX_BUFFER_SIZE)
 			return -EINVAL;
 
-		skb_put(msdu, HAL_RX_DESC_SIZE + l3pad_bytes + msdu_len);
-		skb_pull(msdu, HAL_RX_DESC_SIZE + l3pad_bytes);
+		skb_put(msdu, ab->hw_params.hal_desc_sz + l3pad_bytes + msdu_len);
+		skb_pull(msdu, ab->hw_params.hal_desc_sz + l3pad_bytes);
 	}
 	ath11k_dp_rx_h_ppdu(ar, desc, status);
 
 	ath11k_dp_rx_h_mpdu(ar, msdu, desc, status);
 
-	rxcb->tid = ath11k_dp_rx_h_mpdu_start_tid(desc);
+	rxcb->tid = ath11k_dp_rx_h_mpdu_start_tid(ab, desc);
 
 	/* Please note that caller will having the access to msdu and completing
 	 * rx with mac80211. Need not worry about cleaning up amsdu_list.
@@ -3832,17 +3805,18 @@ static void ath11k_dp_rx_h_tkip_mic_err(struct ath11k *ar, struct sk_buff *msdu,
 					struct ieee80211_rx_status *status)
 {
 	u16 msdu_len;
+	struct ath11k_base *ab = ar->ab;
 	struct hal_rx_desc *desc = (struct hal_rx_desc *)msdu->data;
 	u8 l3pad_bytes;
 	struct ath11k_skb_rxcb *rxcb = ATH11K_SKB_RXCB(msdu);
 
-	rxcb->is_first_msdu = ath11k_dp_rx_h_msdu_end_first_msdu(desc);
-	rxcb->is_last_msdu = ath11k_dp_rx_h_msdu_end_last_msdu(desc);
+	rxcb->is_first_msdu = ath11k_dp_rx_h_msdu_end_first_msdu(ab, desc);
+	rxcb->is_last_msdu = ath11k_dp_rx_h_msdu_end_last_msdu(ab, desc);
 
-	l3pad_bytes = ath11k_dp_rx_h_msdu_end_l3pad(desc);
-	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(desc);
-	skb_put(msdu, HAL_RX_DESC_SIZE + l3pad_bytes + msdu_len);
-	skb_pull(msdu, HAL_RX_DESC_SIZE + l3pad_bytes);
+	l3pad_bytes = ath11k_dp_rx_h_msdu_end_l3pad(ab, desc);
+	msdu_len = ath11k_dp_rx_h_msdu_start_msdu_len(ab, desc);
+	skb_put(msdu, ab->hw_params.hal_desc_sz + l3pad_bytes + msdu_len);
+	skb_pull(msdu, ab->hw_params.hal_desc_sz + l3pad_bytes);
 
 	ath11k_dp_rx_h_ppdu(ar, desc, status);
 
@@ -4299,10 +4273,10 @@ int ath11k_dp_rx_pdev_alloc(struct ath11k_base *ab, int mac_id)
 	return 0;
 }
 
-static void ath11k_dp_mon_set_frag_len(u32 *total_len, u32 *frag_len)
+static void ath11k_dp_mon_set_frag_len(struct ath11k_base *ab, u32 *total_len, u32 *frag_len)
 {
-	if (*total_len >= (DP_RX_BUFFER_SIZE - sizeof(struct hal_rx_desc))) {
-		*frag_len = DP_RX_BUFFER_SIZE - sizeof(struct hal_rx_desc);
+	if (*total_len >= (DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz)) {
+		*frag_len = DP_RX_BUFFER_SIZE - ab->hw_params.hal_desc_sz;
 		*total_len -= *frag_len;
 	} else {
 		*frag_len = *total_len;
@@ -4447,7 +4421,8 @@ static u32 ath11k_dp_rx_mon_comp_ppduid(u32 msdu_ppdu_id, u32 *ppdu_id,
 	return ret;
 }
 
-static void ath11k_dp_mon_get_buf_len(struct hal_rx_msdu_desc_info *info,
+static void ath11k_dp_mon_get_buf_len(struct ath11k_base *ab,
+				      struct hal_rx_msdu_desc_info *info,
 				      bool *is_frag, u32 *total_len,
 				      u32 *frag_len, u32 *msdu_cnt)
 {
@@ -4456,11 +4431,11 @@ static void ath11k_dp_mon_get_buf_len(struct hal_rx_msdu_desc_info *info,
 			*total_len = info->msdu_len;
 			*is_frag = true;
 		}
-		ath11k_dp_mon_set_frag_len(total_len,
+		ath11k_dp_mon_set_frag_len(ab, total_len,
 					   frag_len);
 	} else {
 		if (*is_frag) {
-			ath11k_dp_mon_set_frag_len(total_len,
+			ath11k_dp_mon_set_frag_len(ab, total_len,
 						   frag_len);
 		} else {
 			*frag_len = info->msdu_len;
@@ -4498,6 +4473,7 @@ ath11k_dp_rx_mon_mpdu_pop(struct ath11k *ar, int mac_id,
 	int buf_id;
 	u32 rx_link_buf_info[2];
 	u8 rbm;
+	struct ath11k_base *ab = ar->ab;
 
 	if (!ar->ab->hw_params.rxdma1_enable)
 		rx_ring = &dp->rx_refill_buf_ring;
@@ -4583,11 +4559,11 @@ ath11k_dp_rx_mon_mpdu_pop(struct ath11k *ar, int mac_id,
 
 			rx_desc = (struct hal_rx_desc *)msdu->data;
 
-			rx_pkt_offset = sizeof(struct hal_rx_desc);
-			l2_hdr_offset = ath11k_dp_rx_h_msdu_end_l3pad(rx_desc);
+			rx_pkt_offset = ab->hw_params.hal_desc_sz;
+			l2_hdr_offset = ath11k_dp_rx_h_msdu_end_l3pad(ab, rx_desc);
 
 			if (is_first_msdu) {
-				if (!ath11k_dp_rxdesc_mpdu_valid(rx_desc)) {
+				if (!ath11k_dp_rxdesc_mpdu_valid(ab, rx_desc)) {
 					drop_mpdu = true;
 					dev_kfree_skb_any(msdu);
 					msdu = NULL;
@@ -4596,7 +4572,7 @@ ath11k_dp_rx_mon_mpdu_pop(struct ath11k *ar, int mac_id,
 				}
 
 				msdu_ppdu_id =
-					ath11k_dp_rxdesc_get_ppduid(rx_desc);
+					ath11k_dp_rxdesc_get_ppduid(ab, rx_desc);
 
 				if (ath11k_dp_rx_mon_comp_ppduid(msdu_ppdu_id,
 								 ppdu_id,
@@ -4612,7 +4588,7 @@ ath11k_dp_rx_mon_mpdu_pop(struct ath11k *ar, int mac_id,
 				pmon->mon_last_linkdesc_paddr = paddr;
 				is_first_msdu = false;
 			}
-			ath11k_dp_mon_get_buf_len(&msdu_list.msdu_info[i],
+			ath11k_dp_mon_get_buf_len(ar->ab, &msdu_list.msdu_info[i],
 						  &is_frag, &total_len,
 						  &frag_len, &msdu_cnt);
 			rx_buf_size = rx_pkt_offset + l2_hdr_offset + frag_len;
@@ -4665,12 +4641,12 @@ ath11k_dp_rx_mon_mpdu_pop(struct ath11k *ar, int mac_id,
 	return rx_bufs_used;
 }
 
-static void ath11k_dp_rx_msdus_set_payload(struct sk_buff *msdu)
+static void ath11k_dp_rx_msdus_set_payload(struct ath11k_base *ab, struct sk_buff *msdu)
 {
 	u32 rx_pkt_offset, l2_hdr_offset;
 
-	rx_pkt_offset = sizeof(struct hal_rx_desc);
-	l2_hdr_offset = ath11k_dp_rx_h_msdu_end_l3pad((struct hal_rx_desc *)msdu->data);
+	rx_pkt_offset = ab->hw_params.hal_desc_sz;
+	l2_hdr_offset = ath11k_dp_rx_h_msdu_end_l3pad(ab, (struct hal_rx_desc *)msdu->data);
 	skb_pull(msdu, rx_pkt_offset + l2_hdr_offset);
 }
 
@@ -4694,21 +4670,21 @@ ath11k_dp_rx_mon_merg_msdus(struct ath11k *ar,
 
 	rx_desc = (struct hal_rx_desc *)head_msdu->data;
 
-	if (ath11k_dp_rxdesc_get_mpdulen_err(rx_desc))
+	if (ath11k_dp_rxdesc_get_mpdulen_err(ar->ab, rx_desc))
 		return NULL;
 
-	decap_format = ath11k_dp_rxdesc_get_decap_format(rx_desc);
+	decap_format = ath11k_dp_rxdesc_get_decap_format(ar->ab, rx_desc);
 
 	ath11k_dp_rx_h_ppdu(ar, rx_desc, rxs);
 
 	if (decap_format == DP_RX_DECAP_TYPE_RAW) {
-		ath11k_dp_rx_msdus_set_payload(head_msdu);
+		ath11k_dp_rx_msdus_set_payload(ar->ab, head_msdu);
 
 		prev_buf = head_msdu;
 		msdu = head_msdu->next;
 
 		while (msdu) {
-			ath11k_dp_rx_msdus_set_payload(msdu);
+			ath11k_dp_rx_msdus_set_payload(ar->ab, msdu);
 
 			prev_buf = msdu;
 			msdu = msdu->next;
@@ -4722,7 +4698,7 @@ ath11k_dp_rx_mon_merg_msdus(struct ath11k *ar,
 		u8 qos_pkt = 0;
 
 		rx_desc = (struct hal_rx_desc *)head_msdu->data;
-		hdr_desc = ath11k_dp_rxdesc_get_80211hdr(rx_desc);
+		hdr_desc = ath11k_dp_rxdesc_get_80211hdr(ar->ab, rx_desc);
 
 		/* Base size */
 		wifi_hdr_len = sizeof(struct ieee80211_hdr_3addr);
@@ -4739,7 +4715,7 @@ ath11k_dp_rx_mon_merg_msdus(struct ath11k *ar,
 
 		while (msdu) {
 			rx_desc = (struct hal_rx_desc *)msdu->data;
-			hdr_desc = ath11k_dp_rxdesc_get_80211hdr(rx_desc);
+			hdr_desc = ath11k_dp_rxdesc_get_80211hdr(ar->ab, rx_desc);
 
 			if (qos_pkt) {
 				dest = skb_push(msdu, sizeof(__le16));
@@ -4749,7 +4725,7 @@ ath11k_dp_rx_mon_merg_msdus(struct ath11k *ar,
 				memcpy(dest + wifi_hdr_len,
 				       (u8 *)&qos_field, sizeof(__le16));
 			}
-			ath11k_dp_rx_msdus_set_payload(msdu);
+			ath11k_dp_rx_msdus_set_payload(ar->ab, msdu);
 			prev_buf = msdu;
 			msdu = msdu->next;
 		}
diff --git a/drivers/net/wireless/ath/ath11k/hal.h b/drivers/net/wireless/ath/ath11k/hal.h
index b2c8a3b..eb027c8 100644
--- a/drivers/net/wireless/ath/ath11k/hal.h
+++ b/drivers/net/wireless/ath/ath11k/hal.h
@@ -311,8 +311,6 @@ struct ath11k_base;
 #define HAL_WBM2SW_RELEASE_RING_BASE_MSB_RING_SIZE	0x000fffff
 #define HAL_RXDMA_RING_MAX_SIZE				0x0000ffff
 
-#define HAL_RX_DESC_SIZE (sizeof(struct hal_rx_desc))
-
 /* Add any other errors here and return them in
  * ath11k_hal_rx_desc_get_err().
  */
diff --git a/drivers/net/wireless/ath/ath11k/hw.c b/drivers/net/wireless/ath/ath11k/hw.c
index bb78630..868138f 100644
--- a/drivers/net/wireless/ath/ath11k/hw.c
+++ b/drivers/net/wireless/ath/ath11k/hw.c
@@ -161,11 +161,466 @@ static int ath11k_hw_mac_id_to_srng_id_qca6390(struct ath11k_hw_params *hw,
 	return mac_id;
 }
 
+static u8 *ath11k_hw_rxdesc_80211_hdr_qca6390(struct hal_rx_desc *desc)
+{
+	return desc->u.qca6390.hdr_status;
+}
+
+static u8 *ath11k_hw_rxdesc_80211_hdr_wcn6850(struct hal_rx_desc *desc)
+{
+	return desc->u.wcn6850.hdr_status;
+}
+
+static enum hal_encrypt_type ath11k_hw_rxdesc_mpdu_start_enctype_qca6390(struct hal_rx_desc *desc)
+{
+	if (!(__le32_to_cpu(desc->u.qca6390.mpdu_start.info1) &
+	    RX_MPDU_START_INFO1_ENCRYPT_INFO_VALID))
+		return HAL_ENCRYPT_TYPE_OPEN;
+
+	return FIELD_GET(RX_MPDU_START_INFO2_ENC_TYPE,
+			 __le32_to_cpu(desc->u.qca6390.mpdu_start.info2));
+}
+
+static enum hal_encrypt_type ath11k_hw_rxdesc_mpdu_start_enctype_wcn6850(struct hal_rx_desc *desc)
+{
+	if (!(__le32_to_cpu(desc->u.wcn6850.mpdu_start.info1) &
+	    RX_MPDU_START_INFO1_ENCRYPT_INFO_VALID))
+		return HAL_ENCRYPT_TYPE_OPEN;
+
+	return FIELD_GET(RX_MPDU_START_INFO2_ENC_TYPE,
+			 __le32_to_cpu(desc->u.wcn6850.mpdu_start.info2));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_decap_type_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO2_DECAP_FORMAT,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info2));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_decap_type_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO2_DECAP_FORMAT,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info2));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_mesh_ctl_present_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO2_MESH_CTRL_PRESENT,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info2));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_mesh_ctl_present_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO2_MESH_CTRL_PRESENT,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info2));
+}
+
+static bool ath11k_hw_rxdesc_mpdu_start_seq_ctrl_valid_qca6390(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_MPDU_START_INFO1_MPDU_SEQ_CTRL_VALID,
+			   __le32_to_cpu(desc->u.qca6390.mpdu_start.info1));
+}
+
+static bool ath11k_hw_rxdesc_mpdu_start_seq_ctrl_valid_wcn6850(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_MPDU_START_INFO1_MPDU_SEQ_CTRL_VALID,
+			   __le32_to_cpu(desc->u.wcn6850.mpdu_start.info1));
+}
+
+static bool ath11k_hw_rxdesc_mpdu_start_fc_valid_qca6390(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_MPDU_START_INFO1_MPDU_FCTRL_VALID,
+			   __le32_to_cpu(desc->u.qca6390.mpdu_start.info1));
+}
+
+static bool ath11k_hw_rxdesc_mpdu_start_fc_valid_wcn6850(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_MPDU_START_INFO1_MPDU_FCTRL_VALID,
+			   __le32_to_cpu(desc->u.wcn6850.mpdu_start.info1));
+}
+
+static u16 ath11k_hw_rxdesc_mpdu_start_seq_no_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MPDU_START_INFO1_MPDU_SEQ_NUM,
+			 __le32_to_cpu(desc->u.qca6390.mpdu_start.info1));
+}
+
+static u16 ath11k_hw_rxdesc_mpdu_start_seq_no_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MPDU_START_INFO1_MPDU_SEQ_NUM,
+			 __le32_to_cpu(desc->u.wcn6850.mpdu_start.info1));
+}
+
+static bool ath11k_hw_rxdesc_attn_msdu_done_qca6390(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_ATTENTION_INFO2_MSDU_DONE,
+			   __le32_to_cpu(desc->u.qca6390.attention.info2));
+}
+
+static bool ath11k_hw_rxdesc_attn_msdu_done_wcn6850(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_ATTENTION_INFO2_MSDU_DONE,
+			   __le32_to_cpu(desc->u.wcn6850.attention.info2));
+}
+
+static bool ath11k_hw_rxdesc_attn_l4_cksum_fail_qca6390(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_ATTENTION_INFO1_TCP_UDP_CKSUM_FAIL,
+			   __le32_to_cpu(desc->u.qca6390.attention.info1));
+}
+
+static bool ath11k_hw_rxdesc_attn_l4_cksum_fail_wcn6850(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_ATTENTION_INFO1_TCP_UDP_CKSUM_FAIL,
+			   __le32_to_cpu(desc->u.wcn6850.attention.info1));
+}
+
+static bool ath11k_hw_rxdesc_attn_ip_cksum_fail_qca6390(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_ATTENTION_INFO1_IP_CKSUM_FAIL,
+			   __le32_to_cpu(desc->u.qca6390.attention.info1));
+}
+
+static bool ath11k_hw_rxdesc_attn_ip_cksum_fail_wcn6850(struct hal_rx_desc *desc)
+{
+	return !!FIELD_GET(RX_ATTENTION_INFO1_IP_CKSUM_FAIL,
+			   __le32_to_cpu(desc->u.wcn6850.attention.info1));
+}
+
+static bool ath11k_hw_rxdesc_attn_is_decrypted_qca6390(struct hal_rx_desc *desc)
+{
+	return (FIELD_GET(RX_ATTENTION_INFO2_DCRYPT_STATUS_CODE,
+			  __le32_to_cpu(desc->u.qca6390.attention.info2)) ==
+		RX_DESC_DECRYPT_STATUS_CODE_OK);
+}
+
+static bool ath11k_hw_rxdesc_attn_is_decrypted_wcn6850(struct hal_rx_desc *desc)
+{
+	return (FIELD_GET(RX_ATTENTION_INFO2_DCRYPT_STATUS_CODE,
+			  __le32_to_cpu(desc->u.wcn6850.attention.info2)) ==
+		RX_DESC_DECRYPT_STATUS_CODE_OK);
+}
+
+static struct rx_attention *ath11k_hw_rxdesc_get_attn_qca6390(struct hal_rx_desc *desc)
+{
+	return &desc->u.qca6390.attention;
+}
+
+static struct rx_attention *ath11k_hw_rxdesc_get_attn_wcn6850(struct hal_rx_desc *desc)
+{
+	return &desc->u.wcn6850.attention;
+}
+
+static u16 ath11k_hw_rxdesc_msdu_start_msdu_len_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO1_MSDU_LENGTH,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info1));
+}
+
+static u16 ath11k_hw_rxdesc_msdu_start_msdu_len_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO1_MSDU_LENGTH,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info1));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_sgi_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_SGI,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_sgi_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_SGI,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_rate_mcs_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_RATE_MCS,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_rate_mcs_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_RATE_MCS,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_rx_bw_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_RECV_BW,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_rx_bw_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_RECV_BW,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info3));
+}
+
+static u32 ath11k_hw_rxdesc_msdu_start_freq_qca6390(struct hal_rx_desc *desc)
+{
+	return __le32_to_cpu(desc->u.qca6390.msdu_start.phy_meta_data);
+}
+
+static u32 ath11k_hw_rxdesc_msdu_start_freq_wcn6850(struct hal_rx_desc *desc)
+{
+	return __le32_to_cpu(desc->u.wcn6850.msdu_start.phy_meta_data);
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_pkt_type_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_PKT_TYPE,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_pkt_type_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_PKT_TYPE,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_nss_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_MIMO_SS_BITMAP,
+			 __le32_to_cpu(desc->u.qca6390.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_start_nss_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO3_MIMO_SS_BITMAP,
+			  __le32_to_cpu(desc->u.wcn6850.msdu_start.info3));
+}
+
+static u8 ath11k_hw_rxdesc_mpdu_start_tid_qca6390(struct hal_rx_desc *desc)
+{
+#ifdef RX_MPDU_START_INFO2_TID
+#undef RX_MPDU_START_INFO2_TID
+#endif
+#define RX_MPDU_START_INFO2_TID	GENMASK(17, 14)
+
+	return FIELD_GET(RX_MPDU_START_INFO2_TID,
+			 __le32_to_cpu(desc->u.qca6390.mpdu_start.info2));
+}
+
+static u8 ath11k_hw_rxdesc_mpdu_start_tid_wcn6850(struct hal_rx_desc *desc)
+{
+#ifdef RX_MPDU_START_INFO2_TID
+#undef RX_MPDU_START_INFO2_TID
+#endif
+#define RX_MPDU_START_INFO2_TID	GENMASK(18, 15)
+
+	return FIELD_GET(RX_MPDU_START_INFO2_TID,
+			 __le32_to_cpu(desc->u.wcn6850.mpdu_start.info2));
+}
+
+static u16 ath11k_hw_rxdesc_mpdu_start_peer_id_qca6390(struct hal_rx_desc *desc)
+{
+	return __le16_to_cpu(desc->u.qca6390.mpdu_start.sw_peer_id);
+}
+
+static u16 ath11k_hw_rxdesc_mpdu_start_peer_id_wcn6850(struct hal_rx_desc *desc)
+{
+	return __le16_to_cpu(desc->u.wcn6850.mpdu_start.sw_peer_id);
+}
+
+static u8 ath11k_hw_rxdesc_msdu_end_l3pad_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_END_INFO2_L3_HDR_PADDING,
+			 __le32_to_cpu(desc->u.qca6390.msdu_end.info2));
+}
+
+static u8 ath11k_hw_rxdesc_msdu_end_l3pad_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_END_INFO2_L3_HDR_PADDING,
+			 __le32_to_cpu(desc->u.wcn6850.msdu_end.info2));
+}
+
+static bool ath11k_hw_rxdesc_msdu_end_first_msdu_qca6390(struct hal_rx_desc *desc)
+{
+#ifdef RX_MSDU_END_INFO2_FIRST_MSDU
+#undef RX_MSDU_END_INFO2_FIRST_MSDU
+#endif
+#define RX_MSDU_END_INFO2_FIRST_MSDU BIT(14)
+
+	return !!FIELD_GET(RX_MSDU_END_INFO2_FIRST_MSDU,
+			__le32_to_cpu(desc->u.qca6390.msdu_end.info2));
+}
+
+static bool ath11k_hw_rxdesc_msdu_end_first_msdu_wcn6850(struct hal_rx_desc *desc)
+{
+#ifdef RX_MSDU_END_INFO2_FIRST_MSDU
+#undef RX_MSDU_END_INFO2_FIRST_MSDU
+#endif
+#define RX_MSDU_END_INFO2_FIRST_MSDU BIT(28)
+
+	return !!FIELD_GET(RX_MSDU_END_INFO2_FIRST_MSDU,
+			__le32_to_cpu(desc->u.wcn6850.msdu_end.info2));
+}
+
+static bool ath11k_hw_rxdesc_msdu_end_last_msdu_qca6390(struct hal_rx_desc *desc)
+{
+#ifdef RX_MSDU_END_INFO2_LAST_MSDU
+#undef RX_MSDU_END_INFO2_LAST_MSDU
+#endif
+#define RX_MSDU_END_INFO2_LAST_MSDU BIT(15)
+
+	return !!FIELD_GET(RX_MSDU_END_INFO2_LAST_MSDU,
+			__le32_to_cpu(desc->u.qca6390.msdu_end.info2));
+}
+
+static bool ath11k_hw_rxdesc_msdu_end_last_msdu_wcn6850(struct hal_rx_desc *desc)
+{
+#ifdef RX_MSDU_END_INFO2_LAST_MSDU
+#undef RX_MSDU_END_INFO2_LAST_MSDU
+#endif
+#define RX_MSDU_END_INFO2_LAST_MSDU BIT(29)
+
+	return !!FIELD_GET(RX_MSDU_END_INFO2_LAST_MSDU,
+			__le32_to_cpu(desc->u.wcn6850.msdu_end.info2));
+}
+
+static void ath11k_hw_rxdesc_end_tlv_copy_qca6390(struct hal_rx_desc *fdesc,
+						  struct hal_rx_desc *ldesc)
+{
+	memcpy((u8 *)&fdesc->u.qca6390.msdu_end, (u8 *)&ldesc->u.qca6390.msdu_end,
+	       sizeof(struct rx_msdu_end_qca6390));
+	memcpy((u8 *)&fdesc->u.qca6390.attention, (u8 *)&ldesc->u.qca6390.attention,
+	       sizeof(struct rx_attention));
+	memcpy((u8 *)&fdesc->u.qca6390.mpdu_end, (u8 *)&ldesc->u.qca6390.mpdu_end,
+	       sizeof(struct rx_mpdu_end));
+}
+
+static void ath11k_hw_rxdesc_end_tlv_copy_wcn6850(struct hal_rx_desc *fdesc,
+						  struct hal_rx_desc *ldesc)
+{
+	memcpy((u8 *)&fdesc->u.wcn6850.msdu_end, (u8 *)&ldesc->u.wcn6850.msdu_end,
+	       sizeof(struct rx_msdu_end_wcn6850));
+	memcpy((u8 *)&fdesc->u.wcn6850.attention, (u8 *)&ldesc->u.wcn6850.attention,
+	       sizeof(struct rx_attention));
+	memcpy((u8 *)&fdesc->u.wcn6850.mpdu_end, (u8 *)&ldesc->u.wcn6850.mpdu_end,
+	       sizeof(struct rx_mpdu_end));
+}
+
+static u32 ath11k_hw_rxdesc_get_mpdulen_err_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_ATTENTION_INFO1_MPDU_LEN_ERR,
+			__le32_to_cpu(desc->u.qca6390.attention.info1));
+}
+
+static u32 ath11k_hw_rxdesc_get_mpdulen_err_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_ATTENTION_INFO1_MPDU_LEN_ERR,
+			__le32_to_cpu(desc->u.wcn6850.attention.info1));
+}
+
+static u32 ath11k_hw_rxdesc_get_decap_format_qca6390(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO2_DECAP_FORMAT,
+			__le32_to_cpu(desc->u.qca6390.msdu_start.info2));
+}
+
+static u32 ath11k_hw_rxdesc_get_decap_format_wcn6850(struct hal_rx_desc *desc)
+{
+	return FIELD_GET(RX_MSDU_START_INFO2_DECAP_FORMAT,
+			__le32_to_cpu(desc->u.wcn6850.msdu_start.info2));
+}
+
+static u8 *ath11k_hw_rxdesc_get_80211hdr_qca6390(struct hal_rx_desc *desc)
+{
+	u8 *rx_pkt_hdr;
+
+	rx_pkt_hdr = &desc->u.qca6390.msdu_payload[0];
+
+	return rx_pkt_hdr;
+}
+
+static u8 *ath11k_hw_rxdesc_get_80211hdr_wcn6850(struct hal_rx_desc *desc)
+{
+	u8 *rx_pkt_hdr;
+
+	rx_pkt_hdr = &desc->u.wcn6850.msdu_payload[0];
+
+	return rx_pkt_hdr;
+}
+
+static bool ath11k_hw_rxdesc_mpdu_valid_qca6390(struct hal_rx_desc *desc)
+{
+	u32 tlv_tag;
+
+	tlv_tag = FIELD_GET(HAL_TLV_HDR_TAG,
+			    __le32_to_cpu(desc->u.qca6390.mpdu_start_tag));
+
+	return tlv_tag == HAL_RX_MPDU_START;
+}
+
+static bool ath11k_hw_rxdesc_mpdu_valid_wcn6850(struct hal_rx_desc *desc)
+{
+	u32 tlv_tag;
+
+	tlv_tag = FIELD_GET(HAL_TLV_HDR_TAG,
+			    __le32_to_cpu(desc->u.wcn6850.mpdu_start_tag));
+
+	return tlv_tag == HAL_RX_MPDU_START;
+}
+
+static u32 ath11k_hw_rxdesc_get_ppduid_qca6390(struct hal_rx_desc *desc)
+{
+	return __le16_to_cpu(desc->u.qca6390.mpdu_start.phy_ppdu_id);
+}
+
+static u32 ath11k_hw_rxdesc_get_ppduid_wcn6850(struct hal_rx_desc *desc)
+{
+	return __le16_to_cpu(desc->u.wcn6850.mpdu_start.phy_ppdu_id);
+}
+
+static u32 *ath11k_hw_rxdesc_msdu_start_msdu_len_offset_qca6390(struct hal_rx_desc *desc)
+{
+	return (u32 *)&desc->u.qca6390.msdu_start;
+}
+
+static u32 *ath11k_hw_rxdesc_msdu_start_msdu_len_offset_wcn6850(struct hal_rx_desc *desc)
+{
+	return (u32 *)&desc->u.wcn6850.msdu_start;
+}
+
 const struct ath11k_hw_ops ipq8074_ops = {
 	.get_hw_mac_from_pdev_id = ath11k_hw_ipq8074_mac_from_pdev_id,
 	.wmi_init_config = ath11k_init_wmi_config_ipq8074,
 	.mac_id_to_pdev_id = ath11k_hw_mac_id_to_pdev_id_ipq8074,
 	.mac_id_to_srng_id = ath11k_hw_mac_id_to_srng_id_ipq8074,
+	.rxdesc_80211_hdr = ath11k_hw_rxdesc_80211_hdr_qca6390,
+	.rxdesc_mpdu_start_enctype = ath11k_hw_rxdesc_mpdu_start_enctype_qca6390,
+	.rxdesc_msdu_start_decap_type = ath11k_hw_rxdesc_msdu_start_decap_type_qca6390,
+	.rxdesc_msdu_start_mesh_ctl_present = ath11k_hw_rxdesc_msdu_start_mesh_ctl_present_qca6390,
+	.rxdesc_mpdu_start_seq_ctrl_valid = ath11k_hw_rxdesc_mpdu_start_seq_ctrl_valid_qca6390,
+	.rxdesc_mpdu_start_fc_valid = ath11k_hw_rxdesc_mpdu_start_fc_valid_qca6390,
+	.rxdesc_mpdu_start_seq_no = ath11k_hw_rxdesc_mpdu_start_seq_no_qca6390,
+	.rxdesc_attn_msdu_done = ath11k_hw_rxdesc_attn_msdu_done_qca6390,
+	.rxdesc_attn_l4_cksum_fail = ath11k_hw_rxdesc_attn_l4_cksum_fail_qca6390,
+	.rxdesc_attn_ip_cksum_fail = ath11k_hw_rxdesc_attn_ip_cksum_fail_qca6390,
+	.rxdesc_attn_is_decrypted = ath11k_hw_rxdesc_attn_is_decrypted_qca6390,
+	.rxdesc_get_attn = ath11k_hw_rxdesc_get_attn_qca6390,
+	.rxdesc_msdu_start_msdu_len = ath11k_hw_rxdesc_msdu_start_msdu_len_qca6390,
+	.rxdesc_msdu_start_sgi = ath11k_hw_rxdesc_msdu_start_sgi_qca6390,
+	.rxdesc_msdu_start_rate_mcs = ath11k_hw_rxdesc_msdu_start_rate_mcs_qca6390,
+	.rxdesc_msdu_start_rx_bw = ath11k_hw_rxdesc_msdu_start_rx_bw_qca6390,
+	.rxdesc_msdu_start_freq = ath11k_hw_rxdesc_msdu_start_freq_qca6390,
+	.rxdesc_msdu_start_pkt_type = ath11k_hw_rxdesc_msdu_start_pkt_type_qca6390,
+	.rxdesc_msdu_start_nss = ath11k_hw_rxdesc_msdu_start_nss_qca6390,
+	.rxdesc_mpdu_start_tid = ath11k_hw_rxdesc_mpdu_start_tid_qca6390,
+	.rxdesc_mpdu_start_peer_id = ath11k_hw_rxdesc_mpdu_start_peer_id_qca6390,
+	.rxdesc_msdu_end_l3pad = ath11k_hw_rxdesc_msdu_end_l3pad_qca6390,
+	.rxdesc_msdu_end_first_msdu = ath11k_hw_rxdesc_msdu_end_first_msdu_qca6390,
+	.rxdesc_msdu_end_last_msdu = ath11k_hw_rxdesc_msdu_end_last_msdu_qca6390,
+	.rxdesc_end_tlv_copy = ath11k_hw_rxdesc_end_tlv_copy_qca6390,
+	.rxdesc_get_mpdulen_err = ath11k_hw_rxdesc_get_mpdulen_err_qca6390,
+	.rxdesc_get_decap_format = ath11k_hw_rxdesc_get_decap_format_qca6390,
+	.rxdesc_get_80211hdr = ath11k_hw_rxdesc_get_80211hdr_qca6390,
+	.rxdesc_mpdu_valid = ath11k_hw_rxdesc_mpdu_valid_qca6390,
+	.rxdesc_get_ppduid = ath11k_hw_rxdesc_get_ppduid_qca6390,
+	.rxdesc_msdu_start_msdu_len_offset = ath11k_hw_rxdesc_msdu_start_msdu_len_offset_qca6390,
 };
 
 const struct ath11k_hw_ops ipq6018_ops = {
@@ -173,6 +628,37 @@ const struct ath11k_hw_ops ipq6018_ops = {
 	.wmi_init_config = ath11k_init_wmi_config_ipq8074,
 	.mac_id_to_pdev_id = ath11k_hw_mac_id_to_pdev_id_ipq8074,
 	.mac_id_to_srng_id = ath11k_hw_mac_id_to_srng_id_ipq8074,
+	.rxdesc_80211_hdr = ath11k_hw_rxdesc_80211_hdr_qca6390,
+	.rxdesc_mpdu_start_enctype = ath11k_hw_rxdesc_mpdu_start_enctype_qca6390,
+	.rxdesc_msdu_start_decap_type = ath11k_hw_rxdesc_msdu_start_decap_type_qca6390,
+	.rxdesc_msdu_start_mesh_ctl_present = ath11k_hw_rxdesc_msdu_start_mesh_ctl_present_qca6390,
+	.rxdesc_mpdu_start_seq_ctrl_valid = ath11k_hw_rxdesc_mpdu_start_seq_ctrl_valid_qca6390,
+	.rxdesc_mpdu_start_fc_valid = ath11k_hw_rxdesc_mpdu_start_fc_valid_qca6390,
+	.rxdesc_mpdu_start_seq_no = ath11k_hw_rxdesc_mpdu_start_seq_no_qca6390,
+	.rxdesc_attn_msdu_done = ath11k_hw_rxdesc_attn_msdu_done_qca6390,
+	.rxdesc_attn_l4_cksum_fail = ath11k_hw_rxdesc_attn_l4_cksum_fail_qca6390,
+	.rxdesc_attn_ip_cksum_fail = ath11k_hw_rxdesc_attn_ip_cksum_fail_qca6390,
+	.rxdesc_attn_is_decrypted = ath11k_hw_rxdesc_attn_is_decrypted_qca6390,
+	.rxdesc_get_attn = ath11k_hw_rxdesc_get_attn_qca6390,
+	.rxdesc_msdu_start_msdu_len = ath11k_hw_rxdesc_msdu_start_msdu_len_qca6390,
+	.rxdesc_msdu_start_sgi = ath11k_hw_rxdesc_msdu_start_sgi_qca6390,
+	.rxdesc_msdu_start_rate_mcs = ath11k_hw_rxdesc_msdu_start_rate_mcs_qca6390,
+	.rxdesc_msdu_start_rx_bw = ath11k_hw_rxdesc_msdu_start_rx_bw_qca6390,
+	.rxdesc_msdu_start_freq = ath11k_hw_rxdesc_msdu_start_freq_qca6390,
+	.rxdesc_msdu_start_pkt_type = ath11k_hw_rxdesc_msdu_start_pkt_type_qca6390,
+	.rxdesc_msdu_start_nss = ath11k_hw_rxdesc_msdu_start_nss_qca6390,
+	.rxdesc_mpdu_start_tid = ath11k_hw_rxdesc_mpdu_start_tid_qca6390,
+	.rxdesc_mpdu_start_peer_id = ath11k_hw_rxdesc_mpdu_start_peer_id_qca6390,
+	.rxdesc_msdu_end_l3pad = ath11k_hw_rxdesc_msdu_end_l3pad_qca6390,
+	.rxdesc_msdu_end_first_msdu = ath11k_hw_rxdesc_msdu_end_first_msdu_qca6390,
+	.rxdesc_msdu_end_last_msdu = ath11k_hw_rxdesc_msdu_end_last_msdu_qca6390,
+	.rxdesc_end_tlv_copy = ath11k_hw_rxdesc_end_tlv_copy_qca6390,
+	.rxdesc_get_mpdulen_err = ath11k_hw_rxdesc_get_mpdulen_err_qca6390,
+	.rxdesc_get_decap_format = ath11k_hw_rxdesc_get_decap_format_qca6390,
+	.rxdesc_get_80211hdr = ath11k_hw_rxdesc_get_80211hdr_qca6390,
+	.rxdesc_mpdu_valid = ath11k_hw_rxdesc_mpdu_valid_qca6390,
+	.rxdesc_get_ppduid = ath11k_hw_rxdesc_get_ppduid_qca6390,
+	.rxdesc_msdu_start_msdu_len_offset = ath11k_hw_rxdesc_msdu_start_msdu_len_offset_qca6390,
 };
 
 const struct ath11k_hw_ops qca6390_ops = {
@@ -180,6 +666,75 @@ const struct ath11k_hw_ops qca6390_ops = {
 	.wmi_init_config = ath11k_init_wmi_config_qca6390,
 	.mac_id_to_pdev_id = ath11k_hw_mac_id_to_pdev_id_qca6390,
 	.mac_id_to_srng_id = ath11k_hw_mac_id_to_srng_id_qca6390,
+	.rxdesc_80211_hdr = ath11k_hw_rxdesc_80211_hdr_qca6390,
+	.rxdesc_mpdu_start_enctype = ath11k_hw_rxdesc_mpdu_start_enctype_qca6390,
+	.rxdesc_msdu_start_decap_type = ath11k_hw_rxdesc_msdu_start_decap_type_qca6390,
+	.rxdesc_msdu_start_mesh_ctl_present = ath11k_hw_rxdesc_msdu_start_mesh_ctl_present_qca6390,
+	.rxdesc_mpdu_start_seq_ctrl_valid = ath11k_hw_rxdesc_mpdu_start_seq_ctrl_valid_qca6390,
+	.rxdesc_mpdu_start_fc_valid = ath11k_hw_rxdesc_mpdu_start_fc_valid_qca6390,
+	.rxdesc_mpdu_start_seq_no = ath11k_hw_rxdesc_mpdu_start_seq_no_qca6390,
+	.rxdesc_attn_msdu_done = ath11k_hw_rxdesc_attn_msdu_done_qca6390,
+	.rxdesc_attn_l4_cksum_fail = ath11k_hw_rxdesc_attn_l4_cksum_fail_qca6390,
+	.rxdesc_attn_ip_cksum_fail = ath11k_hw_rxdesc_attn_ip_cksum_fail_qca6390,
+	.rxdesc_attn_is_decrypted = ath11k_hw_rxdesc_attn_is_decrypted_qca6390,
+	.rxdesc_get_attn = ath11k_hw_rxdesc_get_attn_qca6390,
+	.rxdesc_msdu_start_msdu_len = ath11k_hw_rxdesc_msdu_start_msdu_len_qca6390,
+	.rxdesc_msdu_start_sgi = ath11k_hw_rxdesc_msdu_start_sgi_qca6390,
+	.rxdesc_msdu_start_rate_mcs = ath11k_hw_rxdesc_msdu_start_rate_mcs_qca6390,
+	.rxdesc_msdu_start_rx_bw = ath11k_hw_rxdesc_msdu_start_rx_bw_qca6390,
+	.rxdesc_msdu_start_freq = ath11k_hw_rxdesc_msdu_start_freq_qca6390,
+	.rxdesc_msdu_start_pkt_type = ath11k_hw_rxdesc_msdu_start_pkt_type_qca6390,
+	.rxdesc_msdu_start_nss = ath11k_hw_rxdesc_msdu_start_nss_qca6390,
+	.rxdesc_mpdu_start_tid = ath11k_hw_rxdesc_mpdu_start_tid_qca6390,
+	.rxdesc_mpdu_start_peer_id = ath11k_hw_rxdesc_mpdu_start_peer_id_qca6390,
+	.rxdesc_msdu_end_l3pad = ath11k_hw_rxdesc_msdu_end_l3pad_qca6390,
+	.rxdesc_msdu_end_first_msdu = ath11k_hw_rxdesc_msdu_end_first_msdu_qca6390,
+	.rxdesc_msdu_end_last_msdu = ath11k_hw_rxdesc_msdu_end_last_msdu_qca6390,
+	.rxdesc_end_tlv_copy = ath11k_hw_rxdesc_end_tlv_copy_qca6390,
+	.rxdesc_get_mpdulen_err = ath11k_hw_rxdesc_get_mpdulen_err_qca6390,
+	.rxdesc_get_decap_format = ath11k_hw_rxdesc_get_decap_format_qca6390,
+	.rxdesc_get_80211hdr = ath11k_hw_rxdesc_get_80211hdr_qca6390,
+	.rxdesc_mpdu_valid = ath11k_hw_rxdesc_mpdu_valid_qca6390,
+	.rxdesc_get_ppduid = ath11k_hw_rxdesc_get_ppduid_qca6390,
+	.rxdesc_msdu_start_msdu_len_offset = ath11k_hw_rxdesc_msdu_start_msdu_len_offset_qca6390,
+};
+
+const struct ath11k_hw_ops wcn6850_ops = {
+	.get_hw_mac_from_pdev_id = ath11k_hw_ipq8074_mac_from_pdev_id,
+	.wmi_init_config = ath11k_init_wmi_config_qca6390,
+	.mac_id_to_pdev_id = ath11k_hw_mac_id_to_pdev_id_qca6390,
+	.mac_id_to_srng_id = ath11k_hw_mac_id_to_srng_id_qca6390,
+	.rxdesc_80211_hdr = ath11k_hw_rxdesc_80211_hdr_wcn6850,
+	.rxdesc_mpdu_start_enctype = ath11k_hw_rxdesc_mpdu_start_enctype_wcn6850,
+	.rxdesc_msdu_start_decap_type = ath11k_hw_rxdesc_msdu_start_decap_type_wcn6850,
+	.rxdesc_msdu_start_mesh_ctl_present = ath11k_hw_rxdesc_msdu_start_mesh_ctl_present_wcn6850,
+	.rxdesc_mpdu_start_seq_ctrl_valid = ath11k_hw_rxdesc_mpdu_start_seq_ctrl_valid_wcn6850,
+	.rxdesc_mpdu_start_fc_valid = ath11k_hw_rxdesc_mpdu_start_fc_valid_wcn6850,
+	.rxdesc_mpdu_start_seq_no = ath11k_hw_rxdesc_mpdu_start_seq_no_wcn6850,
+	.rxdesc_attn_msdu_done = ath11k_hw_rxdesc_attn_msdu_done_wcn6850,
+	.rxdesc_attn_l4_cksum_fail = ath11k_hw_rxdesc_attn_l4_cksum_fail_wcn6850,
+	.rxdesc_attn_ip_cksum_fail = ath11k_hw_rxdesc_attn_ip_cksum_fail_wcn6850,
+	.rxdesc_attn_is_decrypted = ath11k_hw_rxdesc_attn_is_decrypted_wcn6850,
+	.rxdesc_get_attn = ath11k_hw_rxdesc_get_attn_wcn6850,
+	.rxdesc_msdu_start_msdu_len = ath11k_hw_rxdesc_msdu_start_msdu_len_wcn6850,
+	.rxdesc_msdu_start_sgi = ath11k_hw_rxdesc_msdu_start_sgi_wcn6850,
+	.rxdesc_msdu_start_rate_mcs = ath11k_hw_rxdesc_msdu_start_rate_mcs_wcn6850,
+	.rxdesc_msdu_start_rx_bw = ath11k_hw_rxdesc_msdu_start_rx_bw_wcn6850,
+	.rxdesc_msdu_start_freq = ath11k_hw_rxdesc_msdu_start_freq_wcn6850,
+	.rxdesc_msdu_start_pkt_type = ath11k_hw_rxdesc_msdu_start_pkt_type_wcn6850,
+	.rxdesc_msdu_start_nss = ath11k_hw_rxdesc_msdu_start_nss_wcn6850,
+	.rxdesc_mpdu_start_tid = ath11k_hw_rxdesc_mpdu_start_tid_wcn6850,
+	.rxdesc_mpdu_start_peer_id = ath11k_hw_rxdesc_mpdu_start_peer_id_wcn6850,
+	.rxdesc_msdu_end_l3pad = ath11k_hw_rxdesc_msdu_end_l3pad_wcn6850,
+	.rxdesc_msdu_end_first_msdu = ath11k_hw_rxdesc_msdu_end_first_msdu_wcn6850,
+	.rxdesc_msdu_end_last_msdu = ath11k_hw_rxdesc_msdu_end_last_msdu_wcn6850,
+	.rxdesc_end_tlv_copy = ath11k_hw_rxdesc_end_tlv_copy_wcn6850,
+	.rxdesc_get_mpdulen_err = ath11k_hw_rxdesc_get_mpdulen_err_wcn6850,
+	.rxdesc_get_decap_format = ath11k_hw_rxdesc_get_decap_format_wcn6850,
+	.rxdesc_get_80211hdr = ath11k_hw_rxdesc_get_80211hdr_wcn6850,
+	.rxdesc_mpdu_valid = ath11k_hw_rxdesc_mpdu_valid_wcn6850,
+	.rxdesc_get_ppduid = ath11k_hw_rxdesc_get_ppduid_wcn6850,
+	.rxdesc_msdu_start_msdu_len_offset = ath11k_hw_rxdesc_msdu_start_msdu_len_offset_wcn6850,
 };
 
 #define ATH11K_TX_RING_MASK_0 0x1
diff --git a/drivers/net/wireless/ath/ath11k/hw.h b/drivers/net/wireless/ath/ath11k/hw.h
index fe74ae6..e41bd70 100644
--- a/drivers/net/wireless/ath/ath11k/hw.h
+++ b/drivers/net/wireless/ath/ath11k/hw.h
@@ -7,6 +7,7 @@
 #define ATH11K_HW_H
 
 #include "wmi.h"
+#include "rx_desc.h"
 
 /* Target configuration defines */
 
@@ -175,6 +176,8 @@ struct ath11k_hw_params {
 	bool cold_boot_calib;
 	bool supports_suspend;
 	bool lmac_interrupt;
+
+	u32 hal_desc_sz;
 };
 
 struct ath11k_hw_ops {
@@ -183,11 +186,43 @@ struct ath11k_hw_ops {
 				struct target_resource_config *config);
 	int (*mac_id_to_pdev_id)(struct ath11k_hw_params *hw, int mac_id);
 	int (*mac_id_to_srng_id)(struct ath11k_hw_params *hw, int mac_id);
+	u8* (*rxdesc_80211_hdr)(struct hal_rx_desc *desc);
+	enum hal_encrypt_type (*rxdesc_mpdu_start_enctype)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_decap_type)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_mesh_ctl_present)(struct hal_rx_desc *desc);
+	bool (*rxdesc_mpdu_start_seq_ctrl_valid)(struct hal_rx_desc *desc);
+	bool (*rxdesc_mpdu_start_fc_valid)(struct hal_rx_desc *desc);
+	u16 (*rxdesc_mpdu_start_seq_no)(struct hal_rx_desc *desc);
+	bool (*rxdesc_attn_msdu_done)(struct hal_rx_desc *desc);
+	bool (*rxdesc_attn_l4_cksum_fail)(struct hal_rx_desc *desc);
+	bool (*rxdesc_attn_ip_cksum_fail)(struct hal_rx_desc *desc);
+	bool (*rxdesc_attn_is_decrypted)(struct hal_rx_desc *desc);
+	struct rx_attention* (*rxdesc_get_attn)(struct hal_rx_desc *desc);
+	u16 (*rxdesc_msdu_start_msdu_len)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_sgi)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_rate_mcs)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_rx_bw)(struct hal_rx_desc *desc);
+	u32 (*rxdesc_msdu_start_freq)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_pkt_type)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_start_nss)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_mpdu_start_tid)(struct hal_rx_desc *desc);
+	u16 (*rxdesc_mpdu_start_peer_id)(struct hal_rx_desc *desc);
+	u8 (*rxdesc_msdu_end_l3pad)(struct hal_rx_desc *desc);
+	bool (*rxdesc_msdu_end_first_msdu)(struct hal_rx_desc *desv);
+	bool (*rxdesc_msdu_end_last_msdu)(struct hal_rx_desc *desv);
+	void (*rxdesc_end_tlv_copy)(struct hal_rx_desc *fdesc, struct hal_rx_desc *ldesc);
+	u32 (*rxdesc_get_mpdulen_err)(struct hal_rx_desc *desc);
+	u32 (*rxdesc_get_decap_format)(struct hal_rx_desc *desc);
+	u8* (*rxdesc_get_80211hdr)(struct hal_rx_desc *desc);
+	bool (*rxdesc_mpdu_valid)(struct hal_rx_desc *desc);
+	u32 (*rxdesc_get_ppduid)(struct hal_rx_desc *desc);
+	u32* (*rxdesc_msdu_start_msdu_len_offset)(struct hal_rx_desc *desc);
 };
 
 extern const struct ath11k_hw_ops ipq8074_ops;
 extern const struct ath11k_hw_ops ipq6018_ops;
 extern const struct ath11k_hw_ops qca6390_ops;
+extern const struct ath11k_hw_ops wcn6850_ops;
 
 extern const struct ath11k_hw_ring_mask ath11k_hw_ring_mask_ipq8074;
 extern const struct ath11k_hw_ring_mask ath11k_hw_ring_mask_qca6390;
diff --git a/drivers/net/wireless/ath/ath11k/rx_desc.h b/drivers/net/wireless/ath/ath11k/rx_desc.h
index 670f373..983cb87 100644
--- a/drivers/net/wireless/ath/ath11k/rx_desc.h
+++ b/drivers/net/wireless/ath/ath11k/rx_desc.h
@@ -364,10 +364,21 @@ struct rx_attention {
 #define RX_MPDU_START_INFO2_ALL_FRAME_ENCPD	BIT(1)
 #define RX_MPDU_START_INFO2_ENC_TYPE		GENMASK(5, 2)
 #define RX_MPDU_START_INFO2_VAR_WEP_KEY_WIDTH	GENMASK(7, 6)
-#define RX_MPDU_START_INFO2_MESH_STA		BIT(8)
-#define RX_MPDU_START_INFO2_BSSID_HIT		BIT(9)
-#define RX_MPDU_START_INFO2_BSSID_NUM		GENMASK(13, 10)
-#define RX_MPDU_START_INFO2_TID			GENMASK(17, 14)
+ /* For the following sub fields, WCN6850 is different from
+  * QCA6290/QCA6390
+  *
+  * WCN6850
+  * #define RX_MPDU_START_INFO2_MESH_STA	GENMASK(9, 8)
+  * #define RX_MPDU_START_INFO2_BSSID_HIT	BIT(10)
+  * #define RX_MPDU_START_INFO2_BSSID_NUM	GENMASK(14, 11)
+  * #define RX_MPDU_START_INFO2_TID		GENMASK(18, 15)
+  *
+  * QCA6290/QCA6390
+  * #define RX_MPDU_START_INFO2_MESH_STA	BIT(8)
+  * #define RX_MPDU_START_INFO2_BSSID_HIT	BIT(9)
+  * #define RX_MPDU_START_INFO2_BSSID_NUM	GENMASK(13, 10)
+  * #define RX_MPDU_START_INFO2_TID		GENMASK(17, 14)
+  */
 
 #define RX_MPDU_START_INFO3_REO_DEST_IND		GENMASK(4, 0)
 #define RX_MPDU_START_INFO3_FLOW_ID_TOEPLITZ		BIT(7)
@@ -414,7 +425,7 @@ struct rx_attention {
 
 #define RX_MPDU_START_RAW_MPDU			BIT(0)
 
-struct rx_mpdu_start {
+struct rx_mpdu_start_qca6390 {
 	__le16 info0;
 	__le16 phy_ppdu_id;
 	__le16 ast_index;
@@ -440,6 +451,31 @@ struct rx_mpdu_start {
 	__le32 raw;
 } __packed;
 
+struct rx_mpdu_start_wcn6850 {
+	__le32 info3;
+	__le32 reo_queue_desc_lo;
+	__le32 info4;
+	__le32 pn[4];
+	__le32 info2;
+	__le32 peer_meta_data;
+	__le16 info0;
+	__le16 phy_ppdu_id;
+	__le16 ast_index;
+	__le16 sw_peer_id;
+	__le32 info1;
+	__le32 info5;
+	__le32 info6;
+	__le16 frame_ctrl;
+	__le16 duration;
+	u8 addr1[ETH_ALEN];
+	u8 addr2[ETH_ALEN];
+	u8 addr3[ETH_ALEN];
+	__le16 seq_ctrl;
+	u8 addr4[ETH_ALEN];
+	__le16 qos_ctrl;
+	__le32 ht_ctrl;
+} __packed;
+
 /* rx_mpdu_start
  *
  * rxpcu_mpdu_filter_in_category
@@ -672,7 +708,7 @@ enum rx_msdu_start_reception_type {
 #define RX_MSDU_START_INFO3_RECEPTION_TYPE	GENMASK(23, 21)
 #define RX_MSDU_START_INFO3_MIMO_SS_BITMAP	GENMASK(31, 24)
 
-struct rx_msdu_start {
+struct rx_msdu_start_qca6390 {
 	__le16 info0;
 	__le16 phy_ppdu_id;
 	__le32 info1;
@@ -684,6 +720,20 @@ struct rx_msdu_start {
 	__le32 phy_meta_data;
 } __packed;
 
+struct rx_msdu_start_wcn6850 {
+	__le16 info0;
+	__le16 phy_ppdu_id;
+	__le32 info1;
+	__le32 info2;
+	__le32 toeplitz_hash;
+	__le32 flow_id_toeplitz;
+	__le32 info3;
+	__le32 ppdu_start_timestamp;
+	__le32 phy_meta_data;
+	__le16 vlan_ctag_ci;
+	__le16 vlan_stag_ci;
+} __packed;
+
 /* rx_msdu_start
  *
  * rxpcu_mpdu_filter_in_category
@@ -867,8 +917,17 @@ struct rx_msdu_start {
 #define RX_MSDU_END_INFO1_EXT_WAPI_PN		GENMASK(31, 16)
 
 #define RX_MSDU_END_INFO2_REPORTED_MPDU_LEN	GENMASK(13, 0)
-#define RX_MSDU_END_INFO2_FIRST_MSDU		BIT(14)
-#define RX_MSDU_END_INFO2_LAST_MSDU		BIT(15)
+ /* For the following sub fields, WCN6850 is different from
+  * QCA6290/QCA6390
+  *
+  * QCA6290/QCA6390
+  * #define RX_MSDU_END_INFO2_FIRST_MSDU	BIT(14)
+  * #define RX_MSDU_END_INFO2_LAST_MSDU		BIT(15)
+  *
+  * WCN6850
+  * #define RX_MSDU_END_INFO2_FIRST_MSDU	BIT(28)
+  * #define RX_MSDU_END_INFO2_LAST_MSDU		BIT(29)
+  */
 #define RX_MSDU_END_INFO2_SA_IDX_TIMEOUT	BIT(16)
 #define RX_MSDU_END_INFO2_DA_IDX_TIMEOUT	BIT(17)
 #define RX_MSDU_END_INFO2_MSDU_LIMIT_ERR	BIT(18)
@@ -894,7 +953,7 @@ struct rx_msdu_start {
 #define RX_MSDU_END_INFO5_REO_DEST_IND		GENMASK(5, 1)
 #define RX_MSDU_END_INFO5_FLOW_IDX		GENMASK(25, 6)
 
-struct rx_msdu_end {
+struct rx_msdu_end_qca6390 {
 	__le16 info0;
 	__le16 phy_ppdu_id;
 	__le16 ip_hdr_cksum;
@@ -917,6 +976,31 @@ struct rx_msdu_end {
 	__le16 sa_sw_peer_id;
 } __packed;
 
+struct rx_msdu_end_wcn6850 {
+	__le16 info0;
+	__le16 phy_ppdu_id;
+	__le16 ip_hdr_cksum;
+	__le16 reported_mpdu_len;
+	__le32 info1;
+	__le32 ext_wapi_pn[2];
+	__le32 info4;
+	__le32 ipv6_options_crc;
+	__le32 tcp_seq_num;
+	__le32 tcp_ack_num;
+	__le16 info3;
+	__le16 window_size;
+	__le32 info2;
+	__le16 sa_idx;
+	__le16 da_idx;
+	__le32 info5;
+	__le32 fse_metadata;
+	__le16 cce_metadata;
+	__le16 sa_sw_peer_id;
+	__le32 rule_indication[2];
+	__le32 info6;
+	__le32 info7;
+} __packed;
+
 /* rx_msdu_end
  *
  * rxpcu_mpdu_filter_in_category
@@ -1190,16 +1274,16 @@ struct rx_mpdu_end {
 
 #define HAL_RX_DESC_HDR_STATUS_LEN	120
 
-struct hal_rx_desc {
+struct hal_rx_desc_qca6390 {
 	__le32 msdu_end_tag;
-	struct rx_msdu_end msdu_end;
+	struct rx_msdu_end_qca6390 msdu_end;
 	__le32 rx_attn_tag;
 	struct rx_attention attention;
 	__le32 msdu_start_tag;
-	struct rx_msdu_start msdu_start;
+	struct rx_msdu_start_qca6390 msdu_start;
 	u8 rx_padding0[HAL_RX_DESC_PADDING0_BYTES];
 	__le32 mpdu_start_tag;
-	struct rx_mpdu_start mpdu_start;
+	struct rx_mpdu_start_qca6390 mpdu_start;
 	__le32 mpdu_end_tag;
 	struct rx_mpdu_end mpdu_end;
 	u8 rx_padding1[HAL_RX_DESC_PADDING1_BYTES];
@@ -1209,6 +1293,32 @@ struct hal_rx_desc {
 	u8 msdu_payload[0];
 } __packed;
 
+struct hal_rx_desc_wcn6850 {
+	__le32 msdu_end_tag;
+	struct rx_msdu_end_wcn6850 msdu_end;
+	__le32 rx_attn_tag;
+	struct rx_attention attention;
+	__le32 msdu_start_tag;
+	struct rx_msdu_start_wcn6850 msdu_start;
+	u8 rx_padding0[HAL_RX_DESC_PADDING0_BYTES];
+	__le32 mpdu_start_tag;
+	struct rx_mpdu_start_wcn6850 mpdu_start;
+	__le32 mpdu_end_tag;
+	struct rx_mpdu_end mpdu_end;
+	u8 rx_padding1[HAL_RX_DESC_PADDING1_BYTES];
+	__le32 hdr_status_tag;
+	__le32 phy_ppdu_id;
+	u8 hdr_status[HAL_RX_DESC_HDR_STATUS_LEN];
+	u8 msdu_payload[0];
+} __packed;
+
+struct hal_rx_desc {
+	union {
+		struct hal_rx_desc_qca6390 qca6390;
+		struct hal_rx_desc_wcn6850 wcn6850;
+	} u;
+} __packed;
+
 #define HAL_RX_RU_ALLOC_TYPE_MAX 6
 #define RU_26  1
 #define RU_52  2
-- 
2.7.4

